VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cls_ComDlg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'
'    CommonDialog Class
'
'   ShowOpen      - Datei ffnen Dialog
'   ShowSelect    - Datei Auswahl Dialog
'   ShowSave      - Datei Speichern Dialog
'   ShowPrinter   - Drucker Dialog
'   PageSizeOpen  - DruckerPage ffnen (Gibt hdc und Koordinaten zurck)
'   ShowInfo      - Windows ShellAbout
'   PageSizeClose - DruckerPage schliesen
'
'
'    (Vorlage aus MSDN Library Visual Studio 6.0-Release)
'

'API function called by ShellAbout method
      Private Declare Function ShellAbout Lib "shell32.dll" Alias "ShellAboutA" (ByVal hWnd As Long, ByVal szApp As String, ByVal szOtherStuff As String, ByVal hIcon As Long) As Long
'API function called by ChooseColor method
      Private Declare Function ChooseColor Lib "comdlg32.dll" Alias "ChooseColorA" (pChoosecolor As ChooseColor) As Long
'API function called by ChooseFont method
      Private Declare Function CHOOSEFONT Lib "comdlg32.dll" Alias "ChooseFontA" (pChoosefont As CHOOSEFONT) As Long
'API function inside ShowHelp method
      Private Declare Function WinHelp Lib "user32" Alias "WinHelpA" (ByVal hWnd As Long, ByVal lpHelpFile As String, ByVal wCommand As Long, ByVal dwData As Long) As Long
'API function called by ShowOpen method
      Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OpenFilename) As Long
'API function called by ShowSave method
      Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OpenFilename) As Long
'API function called by ShowPrint method
      Private Declare Function PrintDlg Lib "comdlg32.dll" Alias "PrintDlgA" (pPrintdlg As PrintDlg) As Long
'API function to retrieve extended error information
      Private Declare Function CommDlgExtendedError Lib "comdlg32.dll" () As Long

'API memory functions
      Private Declare Function GlobalAlloc Lib "KERNEL32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
      Private Declare Function GlobalFree Lib "KERNEL32" (ByVal hMem As Long) As Long
      Private Declare Function GlobalLock Lib "KERNEL32" (ByVal hMem As Long) As Long
      Private Declare Function GlobalUnlock Lib "KERNEL32" (ByVal hMem As Long) As Long
      Private Declare Sub CopyMemory Lib "KERNEL32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
      
      Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long
      
'GDI-Drucker-Funktionen
      Private Declare Function StartDoc Lib "gdi32" Alias "StartDocA" (ByVal hdc As Long, lpdi As DocInfo) As Long
      Private Declare Function StartPage Lib "gdi32" (ByVal hdc As Long) As Long
      Private Declare Function EndPage Lib "gdi32" (ByVal hdc As Long) As Long
      Private Declare Function EndDoc Lib "gdi32" (ByVal hdc As Long) As Long
      Private Declare Function Escape Lib "gdi32" (ByVal hdc As Long, ByVal nEscape As Long, ByVal nCount As Long, ByVal lpInData As String, lpOutData As Any) As Long
      Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long


' Konstanten (fr GetDeviceCaps)
      Private Const LOGPIXELSX = 88
      Private Const LOGPIXELSY = 90
      Private Const PHYSICALWIDTH = 110
      Private Const PHYSICALHEIGHT = 111
      Private Const PHYSICALOFFSETX = 112
      Private Const PHYSICALOFFSETY = 113

'constants for API memory functions
      Private Const GMEM_MOVEABLE = &H2
      Private Const GMEM_ZEROINIT = &H40
      Private Const GHND = (GMEM_MOVEABLE Or GMEM_ZEROINIT)
        
'data buffer for the ChooseColor function
      Private Type ChooseColor
              lStructSize As Long
              hwndOwner As Long
              hInstance As Long
              rgbResult As Long
              lpCustColors As Long
              flags As Long
              lCustData As Long
              lpfnHook As Long
              lpTemplateName As String
      End Type
      
'constants for LOGFONT
      Private Const LF_FACESIZE = 32
      Private Const LF_FULLFACESIZE = 64
      Private Const FW_BOLD = 700

'data buffer for the ChooseFont function
      Private Type LOGFONT
              lfHeight As Long
              lfWidth As Long
              lfEscapement As Long
              lfOrientation As Long
              lfWeight As Long
              lfItalic As Byte
              lfUnderline As Byte
              lfStrikeOut As Byte
              lfCharSet As Byte
              lfOutPrecision As Byte
              lfClipPrecision As Byte
              lfQuality As Byte
              lfPitchAndFamily As Byte
              lfFaceName(LF_FACESIZE) As Byte
      End Type

'data buffer for the ChooseFont function
      Private Type CHOOSEFONT
              lStructSize As Long
              hwndOwner As Long
              hdc As Long
              lpLogFont As Long
              iPointSize As Long
              flags As Long
              rgbColors As Long
              lCustData As Long
              lpfnHook As Long
              lpTemplateName As String
              hInstance As Long
              lpszStyle As String
              nFontType As Integer
              MISSING_ALIGNMENT As Integer
              nSizeMin As Long
              nSizeMax As Long
      End Type

'data buffer for the GetOpenFileName and GetSaveFileName functions
      Private Type OpenFilename
              lStructSize As Long
              hwndOwner As Long
              hInstance As Long
              lpstrFilter As String
              lpstrCustomFilter As String
              nMaxCustFilter As Long
              iFilterIndex As Long
              lpstrFile As String
              nMaxFile As Long
              lpstrFileTitle As String
              nMaxFileTitle As Long
              lpstrInitialDir As String
              lpstrTitle As String
              flags As Long
              nFileOffset As Integer
              nFileExtension As Integer
              lpstrDefExt As String
              lCustData As Long
              lpfnHook As Long
              lpTemplateName As String
      End Type

'data buffer for the PrintDlg function
      Private Type PrintDlg
              lStructSize As Long
              hwndOwner As Long
              hDevMode As Long
              hDevNames As Long
              hdc As Long
              flags As Long
              nFromPage As Integer
              nToPage As Integer
              nMinPage As Integer
              nMaxPage As Integer
              nCopies As Integer
              hInstance As Long
              lCustData As Long
              lpfnPrintHook As Long
              lpfnSetupHook As Long
              lpPrintTemplateName As String
              lpSetupTemplateName As String
              hPrintTemplate As Long
              hSetupTemplate As Long
      End Type
      
'fr Startdoc
      Private Type DocInfo
              cbSize As Long
              lpszDocName As String
              lpszOutput As String
      End Type

      Private Type POINTAPI
          X As Long
          Y As Long
      End Type
      
'internal property buffers
      Private iAction As Integer         'internal buffer for Action property
      Private bCancelError As Boolean    'internal buffer for CancelError property
      Private lColor As Long             'internal buffer for Color property
      Private lCopies As Long            'internal buffer for lCopies property
      Private sDefaultExt As String      'internal buffer for sDefaultExt property
      Private sDialogTitle As String     'internal buffer for DialogTitle property
      Private sFileName As String        'internal buffer for FileName property
      Private sFileTitle As String       'internal buffer for FileTitle property
      Private sFilter As String          'internal buffer for Filter property
      Private iFilterIndex As Integer    'internal buffer for FilterIndex property
      Private lFlags As Long             'internal buffer for Flags property
      Private bFontBold As Boolean       'internal buffer for FontBold property
      Private bFontItalic As Boolean     'internal buffer for FontItalic property
      Private sFontName As String        'internal buffer for FontName property
      Private lFontSize As Long          'internal buffer for FontSize property
      Private bFontStrikethru As Boolean 'internal buffer for FontStrikethru property
      Private bFontUnderline As Boolean  'internal buffer for FontUnderline property
      Private lFromPage As Long          'internal buffer for FromPage property
      Private lhdc As Long               'internal buffer for hdc property
      Private lHelpCommand As Long       'internal buffer for HelpCommand property
      Private sHelpContext As String     'internal buffer for HelpContext property
      Private sHelpFile As String        'internal buffer for HelpFile property
      Private sHelpKey As String         'internal buffer for HelpKey property
      Private sInitDir As String         'internal buffer for InitDir property
      Private lMax As Long               'internal buffer for Max property
      Private lMaxFileSize As Long       'internal buffer for MaxFileSize property
      Private lMin As Long               'internal buffer for Min property
      Private objObject As Object        'internal buffer for Object property
      Private iPrinterDefault As Integer 'internal buffer for PrinterDefault property
      Private lToPage As Long            'internal buffer for ToPage property
      
      Private lApiReturn As Long          'internal buffer for APIReturn property
      Private lExtendedError As Long      'internal buffer for ExtendedError property

      Private cbSize As Long
      Private lpszDocName As String
      Private lpszOutput As String


'constants for file dialog
      Private Const OFN_READONLY = &H1
      Private Const OFN_OVERWRITEPROMPT = &H2
      Private Const OFN_HIDEREADONLY = &H4
      Private Const OFN_NOCHANGEDIR = &H8
      Private Const OFN_SHOWHELP = &H10
      Private Const OFN_ENABLEHOOK = &H20
      Private Const OFN_ENABLETEMPLATE = &H40
      Private Const OFN_ENABLETEMPLATEHANDLE = &H80
      Private Const OFN_NOVALIDATE = &H100
      Private Const OFN_ALLOWMULTISELECT = &H200
      Private Const OFN_EXTENSIONDIFFERENT = &H400
      Private Const OFN_PATHMUSTEXIST = &H800
      Private Const OFN_FILEMUSTEXIST = &H1000
      Private Const OFN_CREATEPROMPT = &H2000
      Private Const OFN_SHAREAWARE = &H4000
      Private Const OFN_NOREADONLYRETURN = &H8000
      Private Const OFN_NOTESTFILECREATE = &H10000
      Private Const OFN_NONETWORKBUTTON = &H20000
      Private Const OFN_NOLONGNAMES = &H40000
      Private Const OFN_EXPLORER = &H80000
      Private Const OFN_NODEREFERENCELINKS = &H100000
      Private Const OFN_LONGNAMES = &H200000
      Private Const OFN_SHAREFALLTHROUGH = 2
      Private Const OFN_SHARENOWARN = 1
      Private Const OFN_SHAREWARN = 0

'constants for color dialog
      Private Const CDERR_DIALOGFAILURE = &HFFFF
      Private Const CDERR_FINDRESFAILURE = &H6
      Private Const CDERR_GENERALCODES = &H0
      Private Const CDERR_INITIALIZATION = &H2
      Private Const CDERR_LOADRESFAILURE = &H7
      Private Const CDERR_LOADSTRFAILURE = &H5
      Private Const CDERR_LOCKRESFAILURE = &H8
      Private Const CDERR_MEMALLOCFAILURE = &H9
      Private Const CDERR_MEMLOCKFAILURE = &HA
      Private Const CDERR_NOHINSTANCE = &H4
      Private Const CDERR_NOHOOK = &HB
      Private Const CDERR_NOTEMPLATE = &H3
      Private Const CDERR_REGISTERMSGFAIL = &HC
      Private Const CDERR_STRUCTSIZE = &H1

'constants for file dialog
      Private Const FNERR_BUFFERTOOSMALL = &H3003
      Private Const FNERR_FILENAMECODES = &H3000
      Private Const FNERR_INVALIDFILENAME = &H3002
      Private Const FNERR_SUBCLASSFAILURE = &H3001

      Private Const DM_COPIES As Long = &H100&
      Private Const DM_COLLATE As Long = &H8000
'      Private Const class_POLICY_DATA As Long = 14
'      Private Const ctype_POLICY_DATA As Long = 1

'constants for print dialog
      Private Const PD_RETURNDC = &H100 '#  &H100 + &H400000
      Private Const PD_ALLPAGES = &H0
      Private Const PD_CAN_DRAW_DIB = &H1
      Private Const PD_CAN_STRETCHDIB = &H2
      Private Const PD_COLLATE = &H10
      Private Const PD_CURRENTPAGE = &H400000
      Private Const PD_DISABLEPRINTTOFILE = &H80000
      Private Const PD_ENABLEPRINTHOOK = &H1000
      Private Const PD_ENABLEPRINTTEMPLATE = &H4000
      Private Const PD_ENABLEPRINTTEMPLATEHANDLE = &H10000
      Private Const PD_ENABLESETUPHOOK = &H2000
      Private Const PD_ENABLESETUPTEMPLATE = &H8000
      Private Const PD_ENABLESETUPTEMPLATEHANDLE = &H20000
      Private Const PD_EXCL_COPIESANDCOLLATE = (DM_COPIES Or DM_COLLATE)
      Private Const PD_EXCLUSIONFLAGS = &H1000000
      'Private Const PD_HDR_LEN = sizeof(POLICY_DATA)
      Private Const PD_HIDEPRINTTOFILE = &H100000
      Private Const PD_NOCURRENTPAGE = &H800000
      Private Const PD_NONETWORKBUTTON = &H200000
      Private Const PD_NOPAGENUMS = &H8
      Private Const PD_NOSELECTION = &H4
      Private Const PD_NOWARNING = &H80
      Private Const PD_PAGENUMS = &H2
      Private Const PD_PRINTSETUP = &H40
      Private Const PD_PRINTTOFILE = &H20 '#
      Private Const PD_RESULT_APPLY = 2
      Private Const PD_RESULT_CANCEL = 0
      Private Const PD_RESULT_PRINT = 1
      Private Const PD_RETURNDEFAULT = &H400
      Private Const PD_RETURNIC = &H200
      Private Const PD_SELECTION = &H1
      Private Const PD_SHOWHELP = &H800
      Private Const PD_STRETCHDIB_1_1_OK = &H4
      Private Const PD_STRETCHDIB_1_2_OK = &H8
      Private Const PD_STRETCHDIB_1_N_OK = &H10
      Private Const PD_USEDEVMODECOPIES = &H40000
      Private Const PD_USEDEVMODECOPIESANDCOLLATE = &H40000
      Private Const PD_USELARGETEMPLATE = &H10000000

'#######################################################################################################################

'display the file save dialog box
      Public Function ShowSave(Optional ohdc, Optional oFileName, Optional oFilter, Optional oDialogTitle, Optional oInitDir) As Boolean
          If Not IsMissing(ohdc) Then hdc = ohdc
          If Not IsMissing(oFilter) Then Filter = oFilter
          If Not IsMissing(oFileName) Then FileName = oFileName
          If Not IsMissing(oDialogTitle) Then DialogTitle = oDialogTitle
          If Not IsMissing(oInitDir) Then InitDir = oInitDir
          'flags = IIf(IsMissing(Multi), OFN_HIDEREADONLY Or OFN_FILEMUSTEXIST, OFN_EXPLORER + OFN_ALLOWMULTISELECT)
          ShowFileDialog 2
          ShowSave = lApiReturn
          End Function
          
'display the file open dialog box
      Public Function ShowOpen(Optional ohdc, Optional oFileName, Optional oFilter, Optional oDialogTitle, Optional oInitDir, Optional Multi) As Boolean
          If Not IsMissing(ohdc) Then hdc = ohdc
          If Not IsMissing(oFilter) Then Filter = oFilter
          If Not IsMissing(oFileName) Then FileName = oFileName
          If Not IsMissing(oDialogTitle) Then DialogTitle = oDialogTitle
          If Not IsMissing(oInitDir) Then InitDir = oInitDir
          flags = IIf(IsMissing(Multi), OFN_HIDEREADONLY Or OFN_FILEMUSTEXIST, OFN_EXPLORER + OFN_ALLOWMULTISELECT)
          ShowFileDialog 1
          If (lApiReturn) Then
              If Not IsMissing(oFileName) Then oFileName = FileName
          Else
              If Not IsMissing(oFileName) Then oFileName = ""
          End If
          ShowOpen = lApiReturn
          End Function

'display the file select dialog box
      Public Function ShowSelect(Optional ohdc, Optional oFileName, Optional oFilter, Optional oDialogTitle, Optional oInitDir) As Boolean
          If Not IsMissing(ohdc) Then hdc = ohdc
          If Not IsMissing(oFilter) Then Filter = oFilter
          If Not IsMissing(oFileName) Then FileName = oFileName
          If Not IsMissing(oDialogTitle) Then DialogTitle = oDialogTitle
          If Not IsMissing(oInitDir) Then InitDir = oInitDir
          'flags = IIf(IsMissing(Multi), OFN_HIDEREADONLY Or OFN_FILEMUSTEXIST, OFN_EXPLORER + OFN_ALLOWMULTISELECT)
          CancelError = True
          'DefaultExt = Mid$(oFilter, 3)
          'cmdlg.flags = cdlOfnSaveDefault
          ShowFileDialog 2
          If (lApiReturn) Then
              If Not IsMissing(oFileName) Then oFileName = FileName
          Else
              If Not IsMissing(oFileName) Then oFileName = ""
          End If
          ShowSelect = lApiReturn
          End Function

'display the file dialog for ShowOpen or ShowSave
      Private Sub ShowFileDialog(ByVal iAction As Integer, ParamArray Opt())
          Dim tOpenFile As OpenFilename
          Dim lMaxSize As Long
          Dim sFileNameBuff As String
          Dim sFileTitleBuff As String
          On Error GoTo ShowFileDialogError
          iAction = iAction
          lApiReturn = 0
          lExtendedError = 0
          With tOpenFile
              .lStructSize = Len(tOpenFile)       'lStructSize As Long
              .hwndOwner = lhdc                   'hWndOwner As Long - init from hdc property
              .lpstrFilter = sAPIFilter(sFilter)  'lpstrFilter As String - init from Filter property
              .iFilterIndex = iFilterIndex        'iFilterIndex As Long - init from FilterIndex property
              .hInstance = App.hInstance          '
              .lpstrFile = Space$(254)
              .nMaxFile = 255                     'null terminate
              .lpstrFileTitle = sFileTitle
              .lpstrFileTitle = Space$(254)
              .lpstrInitialDir = sInitDir       'tOpenFile.lpstrInitialDir As String - init from InitDir property
              .lpstrTitle = sDialogTitle        'tOpenFile.lpstrTitle As String - init from DialogTitle property
              .flags = lFlags                   'tOpenFile.flags As Long - init from Flags property
              .lpstrDefExt = sDefaultExt        'tOpenFile.lpstrDefExt As String - init from DefaultExt property
              .nMaxFileTitle = 255
          
          Select Case iAction
              Case 1  'ShowOpen
                  lApiReturn = GetOpenFileName(tOpenFile)
              Case 2  'ShowSave
                  lApiReturn = GetSaveFileName(tOpenFile)
              Case Else   'unknown action
                  Exit Sub
          End Select
          Select Case lApiReturn
              Case 0  'user canceled
                      If bCancelError = True Then Exit Sub  'generate an error
              Case 1
                      sFileName = Trim$(Replace(.lpstrFile, vbNullChar & vbNullChar, vbNullChar))
                      sFileTitle = sLeftOfNull(.lpstrFileTitle)
              Case Else   'an error occured
                        'call CommDlgExtendedError
                        lExtendedError = CommDlgExtendedError
          End Select
          End With
          Exit Sub
ShowFileDialogError:
               Exit Sub
          End Sub
'#######################################################################################################################

'display the print dialog
      Public Function ShowPrinter(Optional ohdc As Long) As Boolean
          Dim tPrintDlg As PrintDlg
          On Error GoTo ShowPrinterError
          If Not IsMissing(ohdc) Then lhdc = ohdc
          iAction = 5  'Action property - ShowPrint
          lApiReturn = 0  'APIReturn property
          lExtendedError = 0  'ExtendedError property
          With tPrintDlg
              .lStructSize = Len(tPrintDlg)
              .hdc = lhdc
              .hwndOwner = lhdc
              .flags = lFlags
              .nFromPage = lFromPage
              .nToPage = lToPage
              .nMinPage = lMin
              .nMaxPage = lMax
              .nCopies = lCopies
          lApiReturn = PrintDlg(tPrintDlg)
          ShowPrinter = lApiReturn
          Select Case lApiReturn
              Case 0  'user canceled
                      'If bCancelError = True Then err.Raise (2001): Exit Function 'generate an error
                      If bCancelError = True Then: Exit Function 'generate an error
              
              Case 1 'user selected OK
                      lFromPage = .nFromPage
                      lToPage = .nToPage
                      lMin = .nMinPage
                      lMax = .nMaxPage
                      lCopies = .nCopies
                      If Not IsMissing(ohdc) Then ohdc = .hdc '.hwndOwner
              Case Else   'an error occured             'call CommDlgExtendedError
                      lExtendedError = CommDlgExtendedError   'store to ExtendedError property
          End Select
          End With
          Exit Function
ShowPrinterError:
              Exit Function
          End Function
          
'#######################################################################################################################


'return object's DocPageSize
      Public Function PageSizeOpen(lHeight As Long, lWidth As Long, Optional ohdc As Long, Optional lSize As Long, Optional lDocName As String, Optional sOutput As String) As Boolean
          Dim tDocInfo As DocInfo
          On Error GoTo StartDocPageError
          If Not IsMissing(ohdc) Then hdc = ohdc
          If Not IsMissing(lSize) Then Size = lSize
          If Not IsMissing(lDocName) Then DocName = lDocName
          If Not IsMissing(sOutput) Then Output = sOutput
          With tDocInfo
              .cbSize = cbSize
              .lpszDocName = lpszDocName
              .lpszOutput = lpszOutput
          End With
          'iAction = 5  'Action property - ShowPrint
          lApiReturn = 0  'APIReturn property
          lExtendedError = 0
          lApiReturn = StartDoc(lhdc, tDocInfo)
          Select Case lApiReturn
              Case 0  'user canceled
              Case Else:
                    StartPage hdc 'user selected OK
                    lWidth = GetDeviceCaps(hdc, PHYSICALWIDTH) - GetDeviceCaps(hdc, PHYSICALOFFSETX) * 2
                    lHeight = GetDeviceCaps(hdc, PHYSICALHEIGHT) - GetDeviceCaps(hdc, PHYSICALOFFSETY) * 2
                    
              'Case Else: lExtendedError = CommDlgExtendedError     'store to ExtendedError property
          End Select
          Exit Function
StartDocPageError:
              Exit Function
      End Function

'assign object's PageSizeClose
      Public Function PageSizeClose(Optional ohdc As Long) As Boolean
          On Error GoTo PageSizeClose
          If Not IsMissing(ohdc) Then hdc = ohdc
          lApiReturn = 0  'APIReturn property
          lExtendedError = 0
          lApiReturn = EndPage(lhdc)
          Select Case lApiReturn
              Case 0:
              Case 1:
              Case Else: lExtendedError = CommDlgExtendedError     'store to ExtendedError property
          End Select
          lApiReturn = EndDoc(lhdc)
          Select Case lApiReturn
              Case 0:
              Case 1:
              Case Else: lExtendedError = CommDlgExtendedError     'store to ExtendedError property
          End Select
          Exit Function
PageSizeClose:
              Exit Function
      End Function
      
'#######################################################################################################################
'Programm info
      Public Sub ShowInfo()
          Call ShellAbout(lhdc, App.Title, App.ProductName, mdi.Icon)
          End Sub

'#######################################################################################################################

'display the color dialog box
Public Function ShowColor() As Long
    Dim tChooseColor As ChooseColor
    Dim alCustomColors(15) As Long
    Dim lCustomColorSize As Long
    Dim lCustomColorAddress As Long
    Dim lMemHandle As Long
    Dim n As Integer
    iAction = 3  'Action property - ShowColor
    lApiReturn = 0  'APIReturn property
    lExtendedError = 0  'ExtendedError property
    With tChooseColor
          .lStructSize = Len(tChooseColor)
          .hwndOwner = lhdc
          .rgbResult = lColor
          For n = 0 To UBound(alCustomColors)
              alCustomColors(n) = &HFFFFFF
          Next
          lCustomColorSize = Len(alCustomColors(0)) * 16 ' Get size of memory needed for custom colors
          lMemHandle = GlobalAlloc(GHND, lCustomColorSize) ' Get a global memory block to hold a copy of the custom colors
          If lMemHandle = 0 Then
              Exit Function
          End If
          lCustomColorAddress = GlobalLock(lMemHandle) ' Lock the custom color's global memory block
          If lCustomColorAddress = 0 Then
              Exit Function
          End If
          Call CopyMemory(ByVal lCustomColorAddress, alCustomColors(0), lCustomColorSize) ' Copy custom colors to the global memory block
          .lpCustColors = lCustomColorAddress
          .flags = lFlags
          lApiReturn = ChooseColor(tChooseColor) '***    call the ChooseColor API function
    End With
    Select Case lApiReturn
        Case 0  'user canceled
            If bCancelError = True Then
                err.Raise Number:=vbObjectError + 894, Description:="Cancel Pressed"
                Exit Function
            End If
        Case 1  'user selected a color
            'update property buffer
            lColor = tChooseColor.rgbResult
            ShowColor = tChooseColor.rgbResult
        Case Else   'an error occured
            'call CommDlgExtendedError
            lExtendedError = CommDlgExtendedError
    End Select
Exit Function
ShowColorError:
    Exit Function
End Function

'#######################################################################################################################

'ShowDialog to Mouse
      Public Sub ShowForm(frm As Form, Optional vb_modal)
          Dim MPoint As POINTAPI, offset%, f_hight%, f_width%
          offset% = 40
          GetCursorPos MPoint
          f_hight% = TwipsToPixelX(frm.Height) / 1.8 + offset%
          f_width% = TwipsToPixelX(frm.Width) / 1.9 + offset%
          frm.Left = PixelToTwipsX((MPoint.X)) - frm.Width / 4
          frm.Top = PixelToTwipsY((MPoint.Y)) - frm.Height * 0.08
          'frm.VISIBLE = True
          frm.Show vb_modal
        'oberstes Fenster
          'SetWindowPos frm.hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE + SWP_NOSIZE
          End Sub
          
'Twips in Pixel umrechnen
      Public Function TwipsToPixelX(Twips&) As Long ' Integer
          TwipsToPixelX = CLng(Twips& / Screen.TwipsPerPixelX)
          End Function
      Public Function TwipsToPixelY(Twips&) As Long 'Integer
          TwipsToPixelY = CLng(Twips& / Screen.TwipsPerPixelY)
          End Function
          
'Pixel in Twips umrechnen
      Public Function PixelToTwipsY(Pixel%) As Long
          PixelToTwipsY = Screen.TwipsPerPixelY * Pixel%
          End Function
      Public Function PixelToTwipsX(Pixel%) As Long
          PixelToTwipsX = Screen.TwipsPerPixelX * Pixel%
          End Function
          
'#######################################################################################################################
       
'return object's Size property
      Public Property Get Size() As String
          Size = cbSize
          End Property
        
'assign object's Size property
      Public Property Let Size(vNewValue As String)
          cbSize = vNewValue
          End Property

'return object's Output property
      Public Property Get Output() As String
          Output = lpszOutput
          End Property
        
'assign object's Output property
      Public Property Let Output(vNewValue As String)
          lpszOutput = vNewValue
          End Property
 
'return object's DocName property
      Public Property Get DocName() As String
          DocName = lpszDocName
          End Property
        
'assign object's DocName property
      Public Property Let DocName(vNewValue As String)
          lpszDocName = vNewValue
          End Property
      
'###################################### Private Function ##########################################################


'returns the part of sIn preceding Chr$(0)
    Private Function sLeftOfNull(ByVal sIn As String)
        Dim lNullPos As Long
        sLeftOfNull = sIn 'init output
        lNullPos = InStr(sIn, Chr$(0)) 'get position of first Chr$(0) in sIn
        If lNullPos > 0 Then sLeftOfNull = Mid$(sIn, 1, lNullPos - 1) 'return part of sIn to left of first Chr$(0) if found
        End Function

'prepares sIn for use as a filter string in API common dialog functions
      Private Function sAPIFilter(sIn)
          Dim lChrNdx As Long
          Dim sOneChr As String
          Dim sOutStr As String
          'convert any | characters to nulls
          For lChrNdx = 1 To Len(sIn)
              sOneChr = Mid$(sIn, lChrNdx, 1)
              If sOneChr = "|" Then
                  sOutStr = sOutStr & Chr$(0)
              Else
                  sOutStr = sOutStr & sOneChr
              End If
          Next
          sOutStr = sOutStr & Chr$(0) 'add a null to the end
          sAPIFilter = sOutStr 'return sOutStr
          End Function
          
'Return object's Action property
      Public Property Get Action() As Integer
          Action = iAction
          End Property
    
'return object's FileName property
      Public Property Get FileName() As String
          FileName = sFileName
          End Property
        
'assign object's FileName property
      Public Property Let FileName(vNewValue As String)
          sFileName = vNewValue
          End Property

'assign object's Filter property
      Public Property Let Filter(vNewValue As String)
          sFilter = vNewValue
          End Property
        
'return object's FilterIndex property
      Public Property Get FilterIndex() As Integer
          FilterIndex = iFilterIndex
          End Property
        
'assign object's FilterIndex property
      Public Property Let FilterIndex(vNewValue As Integer)
          iFilterIndex = vNewValue
          End Property

'return object's FileName property
      Public Property Get DialogTitle() As String
          DialogTitle = sDialogTitle
          End Property

'assign object's DialogTitle property
      Public Property Let DialogTitle(vNewValue As String)
          sDialogTitle = vNewValue
          End Property
        
'return object's Flags property
      Public Property Get flags() As Long
          flags = lFlags
          End Property
        
'assign object's Flags property
      Public Property Let flags(vNewValue As Long)
          lFlags = vNewValue
          End Property

'Return object's hDC property
      Public Property Get hdc() As Long
          hdc = lhdc
          End Property
        
'Assign object's hDC property
      Public Property Let hdc(vNewValue As Long)
          lhdc = vNewValue
          End Property

'Return object's InitDir property
      Public Property Get InitDir() As String
          InitDir = sInitDir
          End Property
        
'Assign object's InitDir property
      Public Property Let InitDir(vNewValue As String)
          sInitDir = vNewValue
          End Property

'assign object's FileTitle property
      Public Property Let FileTitle(vNewValue As String)
          sFileTitle = vNewValue
          End Property
    
'return object's APIReturn property
      Public Property Get APIReturn() As Long
          APIReturn = lApiReturn
          End Property
        
'return object's ExtendedError property
      Public Property Get ExtendedError() As Long
          ExtendedError = lExtendedError
          End Property

'return object's Filter property
      Public Property Get Filter() As String
          Filter = sFilter
          End Property
    
'Return object's Max property
      Public Property Get Max() As Long
          Max = lMax
          End Property
'Assign object's - property
      Public Property Let Max(vNewValue As Long)
          lMax = vNewValue
          End Property

'Return object's Min property
      Public Property Get min() As Long
          min = lMin
          End Property
    
'Assign object's Min property
      Public Property Let min(vNewValue As Long)
          lMin = vNewValue
          End Property

'Return object's PrinterDefault property
      Public Property Get PrinterDefault() As Integer
          PrinterDefault = iPrinterDefault
          End Property
    
'Assign object's PrinterDefault property
      Public Property Let PrinterDefault(vNewValue As Integer)
          iPrinterDefault = vNewValue
          End Property
    
'Return object's CancelError property
      Public Property Get CancelError() As Boolean
          CancelError = bCancelError
          End Property
'Assign object's CancelError property
      Public Property Let CancelError(vNewValue As Boolean)
          bCancelError = vNewValue
          End Property
          
'return object's Copies property
      Public Property Get Copies() As Long
          Copies = lCopies
          End Property
    
'assign object's Copies property
      Public Property Let Copies(vNewValue As Long)
          lCopies = vNewValue
          End Property

'Return object's ToPage property
      Public Property Get ToPage() As Long
          ToPage = lToPage
          End Property
    
'Assign object's ToPage property
      Public Property Let ToPage(vNewValue As Long)
          lToPage = vNewValue
          End Property

'Return object's FromPAge property
      Public Property Get FromPage() As Long
          FromPage = lFromPage
          End Property
'Assign object's FromPage property
      Public Property Let FromPage(vNewValue As Long)
          lFromPage = vNewValue
          End Property

