VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CParser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private StartTime       As Date         'Startzeitpunkt
Private NextItem        As Date         'Gesuchter Zeitpunkt
Private LastItem        As Date         'Letzter Zeitpunkt

Public Event ParseError(m_Number As Long, m_Description As String)

Public Function Parse(Optional D As Date, Optional Path As String) As Boolean
    If D = #12:00:00 AM# Then D = Now   'Zeit auf aktuelle Zeit setzen, wenn nichts anderes festgelegt
    If Path = "" Then Path = App.Path   'Path auf App.Path setzen, wenn nicht anders festgelegt
    
    Call SetLastQuarterHour(D)          'Zurckspringen zur letzten vollen Viertelstunde
    D = DateAdd("d", -1, D)             'Einen Tag zurck gehen: Hier fngt das Diagramm an
    DStartTime = D
    
    StartTime = D                       'Startzeit wird gesetzt
    NextItem = D                        'Nchster zu suchender Zeitpunkt wird gesetzt
    LastItem = DateAdd("n", -15, D)     'Letzter "virtueller" Zeitpunkt: 15 Minuten vor Start
    
    Call ClearArray
    Parse = StartReading(Path)          'Einlesevorgang starten
End Function

Private Sub ClearArray()
    'Diese Sub setzt alle Werte zurck ...
    Dim I As Long
    For I = 0 To ITEMCOUNT
        Datas(I).X = -1
        Datas(I).Y = -1
        Datas(I).Tag = ""
    Next
    MaxItem = 0
End Sub

Private Function StartReading(Path As String) As Boolean
    Dim ff      As Long
    Dim tmp     As String
    Dim cnt     As Long         'counter

    StartReading = True
    
    'An Path ein \ dranhgen, wenn noch nicht vorhanden
    If RightB$(Path, 1) <> "\" Then Path = Path & "\"
    
    cnt = -1
    
    Do
        
        ff = FreeFile
        'Einlesen der ersten Datei
        If Not FileExists(Path & Format$(NextItem, "yyyymmdd") & ".txt") Then
            RaiseEvent ParseError(1, "Dateien zum Auslesen nicht gefunden!")
            StartReading = False
            Exit Function
        End If
        Open Path & Format$(NextItem, "yyyymmdd") & ".txt" For Input As #ff
        
        'Einlesen des Datums und Vergleich
        Line Input #ff, tmp
        If CDate(tmp) <> CDate(Format(NextItem, "dd.mm.yyyy")) Then
            RaiseEvent ParseError(2, "Fehler beim Auslesen der Datei: Datum verkehrt")
            StartReading = False
            Exit Function
        End If
        
        'Leere Zeile
        Line Input #ff, tmp
            
        'Rest der Datei einlesen
        Do Until EOF(ff)
            Line Input #ff, tmp
            Call CheckItem(tmp, cnt)            'Linie auswerten
            If cnt > ITEMCOUNT Then Exit Function 'Zuende ausgelesen ?
        Loop
        
        Close #ff
        
    Loop
    
End Function

Private Sub CheckItem(ParsedLine As String, ByRef Count As Long)
    Dim ParseDate   As Date
    Dim LineItems() As String
    Dim Minutes     As Long
    
    LineItems() = Split(ParsedLine, " ")                                'Bei Leerzeichen splitten
    
    ParseDate = CDate(Format$(NextItem, "dd.mm.yyyy ") & LineItems(0))  'Als Datum darstellen
    
    Minutes = DateDiff("n", LastItem, ParseDate)                        'Zeitabstand zum letzten Item in Minuten
    If Minutes <= 0 Then Exit Sub
    Count = Count + (Minutes / 15)                                      'nun in Viertelstunden ...
    
    If Count > ITEMCOUNT Then _
        Exit Sub
    
    Datas(Count).X = Count
    Datas(Count).Y = CLng(LineItems(1))
    Datas(Count).Tag = Format$(ParseDate, "DDDD, \der dd.mm.yy, hh:mm:") & _
                        vbCrLf & MEASURE_NAME & ": " & LineItems(1) & " " & MEASURE_UNIT
                    
    If CLng(LineItems(1)) > MaxItem Then _
        MaxItem = CLng(LineItems(1))
                            
    LastItem = ParseDate
    NextItem = DateAdd("n", 15, ParseDate)
End Sub

Private Sub SetLastQuarterHour(ByRef D As Date)
    Dim tmp     As Long
    tmp = CLng(Format$(D, "nn"))    'Anzahl der Minuten seit der letzten vollen Stunde
    tmp = Fix(tmp / 15)             'Anzahl der Viertelstunden seit der letzten vollen Stunde
        
    D = CDate(Format(D, "dd.mm.yyyy hh:") & CStr(tmp * 15))
End Sub

Private Function FileExists(Path As String) As Boolean
    'Diese Funktion gibt als Boolean zurck, ob eine Datei existiert oder nicht
    Const NotFile = vbDirectory Or vbVolume

    On Error Resume Next
    FileExists = (GetAttr(Path) And NotFile) = 0
    On Error GoTo 0
End Function


