VERSION 5.00
Begin VB.Form mainFrm 
   Caption         =   "Liniendiagramm"
   ClientHeight    =   3330
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6015
   Icon            =   "mainFrm.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3330
   ScaleWidth      =   6015
   StartUpPosition =   3  'Windows Default
   Begin VB.HScrollBar HScroll 
      Height          =   255
      Left            =   240
      Max             =   8
      Min             =   1
      TabIndex        =   2
      Top             =   3120
      Value           =   2
      Width           =   5775
   End
   Begin VB.VScrollBar VScroll 
      Height          =   3255
      LargeChange     =   5
      Left            =   0
      Max             =   25
      Min             =   3
      SmallChange     =   2
      TabIndex        =   1
      Top             =   0
      Value           =   5
      Width           =   255
   End
   Begin VB.PictureBox diagrammPic 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   3135
      Left            =   240
      ScaleHeight     =   3105
      ScaleWidth      =   5745
      TabIndex        =   0
      Top             =   0
      Width           =   5775
   End
End
Attribute VB_Name = "mainFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Datei Inhalt (Zeiten = rechte Seite, Zahlen = linke Seite)
Dim Zeiten(), Zahlen()
'Grte Zahl
Dim GroessteZahl


Private Sub Form_Load()
    Dim Datei
    
    'Datei festlegen
    Datei = OptionenFrm.File
    If Left(Datei, 1) = "\" Then Datei = App.Path & Datei
    
    'Datei einlesen und in Variablen "Zeiten" und "Zahlen" schreiben
    Einlesen (Datei)
End Sub

'Anpassen der Gren
Private Sub Form_Resize()

    'Anpassen der Gre des senkrechten Scroll-balkens
    Me.VScroll.Left = 0
    Me.VScroll.Top = 0
    Me.VScroll.Height = Me.Height - 400
    
    'Anpassen der Gre des waagrechten Scroll-balkens
    Me.HScroll.Left = 240
    Me.HScroll.Top = Me.Height - 640
    Me.HScroll.Width = Me.Width - Me.HScroll.Left - 120
    
    'Anpassen der Gre des Bildes
    Me.diagrammPic.Left = Me.VScroll.Left + Me.VScroll.Width
    Me.diagrammPic.Top = 0
    Me.diagrammPic.Width = Me.Width - (Me.VScroll.Left + Me.VScroll.Width)
    Me.diagrammPic.Height = Me.VScroll.Height - Me.HScroll.Height
    
    DiagrammAnzeigen
End Sub

'Datei einlesen und in Variablen schreiben
Private Sub Einlesen(Datei)
    On Error GoTo Fehler
    'Zeile = Aktuell eingelesene Zeile aus der Datei
    Dim Zeile
    'Gre von "Zeiten" und "Zahlen" auf 0 setzen
    ReDim Zeiten(0)
    ReDim Zahlen(0)
      
    'Datei einlesen
    Open Datei For Input As #1
    
    'Datum einlesen und in Titel schreiben
    Line Input #1, Zeile
    Me.Caption = "Liniendiagramm - [" & Zeile & "]"
    'Leerzeile einlesen
    Line Input #1, Zeile
    
    'Jede Zeile einlesen
    Do Until EOF(1)
        'Variablen "Zeiten" und "Zahlen" um eins vergrern
        ReDim Preserve Zeiten(UBound(Zeiten) + 1)
        ReDim Preserve Zahlen(UBound(Zahlen) + 1)
        Line Input #1, Zeile
        
        Zeiten(UBound(Zeiten)) = Format(Left(Zeile, 5), "hhmm")
        Zahlen(UBound(Zahlen)) = Mid(Zeile, 7)
        'Grte Zahl festlegen
        If Val(Zahlen(UBound(Zahlen))) > Val(GroessteZahl) Then GroessteZahl = Zahlen(UBound(Zahlen))
    Loop
    
    DiagrammAnzeigen
   Exit Sub
   
'berprfen von Fehlern
Fehler:
    'Fehlermeldung ausgeben
    MsgBox "Fehler" & Str(Err) & ": " & Error(Err), 16, "Fehler" & Str(Err)
    'Programm Beenden
    End
End Sub

'Raster und Diagramm anzeigen
Private Sub DiagrammAnzeigen()
    On Error Resume Next
    Dim GerundeteZahl, i, x, y
    
    'Bild leeren
    Me.diagrammPic.Cls
    
    'Zahl runden
    GerundeteZahl = GroessteZahl / (10 ^ (Len(GroessteZahl) - 1))
    GerundeteZahl = Int(GerundeteZahl) + 1
    GerundeteZahl = GerundeteZahl * (10 ^ (Len(GroessteZahl) - 1))

    'Waagrechte Linien
    For i = 0 To VScroll
        'y = Hhe der Linien
        y = i * Me.diagrammPic.Height / VScroll
        Me.diagrammPic.Line (0, y)-(Me.diagrammPic.Width, y)
    
        'Zahl angeben
        Me.diagrammPic.CurrentX = 0
        Me.diagrammPic.CurrentY = y
        Me.diagrammPic.Print Round(GerundeteZahl - (GerundeteZahl / VScroll) * i)
    
    Next
    
    'Senkrechte Linien
    For i = Me.HScroll To 24 Step Me.HScroll
        x = i * Me.diagrammPic.Width / 24
        Me.diagrammPic.Line (x, 0)-(x, Me.diagrammPic.Height)
        
        'Zeit angeben
        Me.diagrammPic.CurrentX = x
        Me.diagrammPic.CurrentY = Me.diagrammPic.Height - 240
        Me.diagrammPic.Print i & ":00"
    Next
    
    'Auerhalb des Diagramms beginnnen, damit der erste Wert stimmt
    Me.diagrammPic.CurrentX = -100
    'Diagramm zeichnen
    For i = 1 To UBound(Zeiten)
        Me.diagrammPic.Line -(Me.diagrammPic.Width / (2400 / Zeiten(i)), Me.diagrammPic.Height - (Me.diagrammPic.Height / (GerundeteZahl / Zahlen(i)))), Me.diagrammPic.Tag
    Next
    
    'Linie nach rechts fortsetzen
    If Me.diagrammPic.CurrentX < Me.diagrammPic.Width Then
        Me.diagrammPic.Line -(Me.diagrammPic.Width, Me.diagrammPic.CurrentY), Me.diagrammPic.Tag
    End If
End Sub

'Programm beenden
Private Sub Form_Unload(Cancel As Integer)
    Unload OptionenFrm
End Sub

'Markierung von der horizontalen Scrollleiste nehmen
Private Sub HScroll_GotFocus()
    Me.diagrammPic.SetFocus
End Sub

'Diagramm erneut zeichnen, wenn die horinzontale Scrollleiste verndert wird
Private Sub HScroll_Scroll()
    DiagrammAnzeigen
End Sub

'Markierung von der vertikalen Scrollleiste nehmen
Private Sub VScroll_GotFocus()
    Me.diagrammPic.SetFocus
End Sub

'Diagramm erneut zeichnen, wenn die vertikale Scrollleiste verndert wird
Private Sub VScroll_Scroll()
    DiagrammAnzeigen
End Sub
