VERSION 5.00
Begin VB.UserControl ColorPicker 
   Appearance      =   0  'Flat
   CanGetFocus     =   0   'False
   ClientHeight    =   525
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1290
   ClipControls    =   0   'False
   MouseIcon       =   "ucColorPicker.ctx":0000
   ScaleHeight     =   35
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   86
End
Attribute VB_Name = "ColorPicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'V1.0 2001-03-11
' G.Beckmann  EMail: G.Beckmann@NikoCity.de

'/ API
Private Type BITMAPINFOHEADER
    biSize              As Long
    biWidth             As Long
    biHeight            As Long
    biPlanes            As Integer
    biBitCount          As Integer
    biCompression       As Long
    biSizeImage         As Long
    biXPelsPerMeter     As Long
    biYPelsPerMeter     As Long
    biClrUsed           As Long
    biClrImportant      As Long
End Type

Private Type RECT
    Left                As Long
    Top                 As Long
    Right               As Long
    Bottom              As Long
End Type

Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function FrameRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function InflateRect Lib "user32" (lpRect As RECT, ByVal x As Long, ByVal y As Long) As Long
Private Declare Function PtInRect Lib "user32" (lpRect As RECT, ByVal x&, ByVal y&) As Long
Private Declare Function DrawIconEx Lib "user32" (ByVal hdc As Long, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As Long, ByVal hbrFlickerFreeDraw As Long, ByVal diFlags As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Declare Function StretchDIBits& Lib "gdi32" (ByVal hdc&, ByVal x&, ByVal y&, ByVal dx&, ByVal dy&, ByVal SrcX&, ByVal SrcY&, ByVal wSrcWidth&, ByVal wSrcHeight&, lpBits As Any, lpBitsInfo As Any, ByVal wUsage As Long, ByVal dwRop&)
Private Declare Function GetStockObject Lib "gdi32" (ByVal nIndex As Long) As Long
Private Declare Function SetStretchBltMode Lib "gdi32" (ByVal hdc As Long, ByVal nStretchMode As Long) As Long
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Private Const BLACK_BRUSH = 4
Private Const BI_RGB = 0&
Private Const DIB_RGB_COLORS = 0
Private Const HALFTONE = 4
Private Const DI_NORMAL = 3

'//
Private Const MARGIN = 4
Private Const PRP_COLOR = "A"

Private m_aDIB(256 * 9 - 1) As Byte     ' Gerteunabhngige Bitmap (DIB) mit Farbverlufen
Private m_aRc(3)            As RECT     ' Vier Rechtecke:Rot, Grn, Blau und Vorschau
Private m_iCurArea          As Long     ' Selektierter Bereich (Rechteck)
Private m_iScaleRange       As Long     ' Strecke einer Farbskala
Private m_aSelectorPos(2)   As Long     ' Position der Schieberegler
Private m_aRGB(2)           As Integer  ' Farbanteile (Rot,Grn,Blau)
Private m_Color             As Long     ' Aktueller Farbwert

Public Event ColorChanged(ByVal NewColor As OLE_COLOR)

Public Property Get Color() As OLE_COLOR
    Color = m_Color
End Property

Public Property Let Color(ByVal I As OLE_COLOR)
    Dim C&, ipos&
    If I < 0 Then I = GetSysColor(I And &HFF&)
    If m_Color <> I Then
        m_aRGB(0) = I And &HFF&
        m_aRGB(1) = (I \ &H100) And &HFF&
        m_aRGB(2) = I \ &H10000
        For C = 0 To 2
            ipos = (m_iScaleRange * m_aRGB(C)) \ 255
            If m_aSelectorPos(C) <> ipos Then
                pEraseSelector C
                m_aSelectorPos(C) = ipos
                pDrawSelector C
            End If
        Next C
        pDrawPreview False
        m_Color = I
    End If
End Property

Private Sub UserControl_Initialize()
    pInitDIB
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dim iCol&, rc As RECT
    iCol = RGB(m_aRGB(0), m_aRGB(1), m_aRGB(2))
    If m_Color <> iCol Then
        GetClientRect UserControl.hwnd, rc
        If PtInRect(rc, x, y) Then
            RaiseEvent ColorChanged(iCol)
        Else 'Undo
            iCol = m_Color
        End If
        m_Color = Not m_Color: Color() = iCol
        pDrawPreview False
    End If
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    UserControl_MouseMove Button, Shift, x, y
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    m_iCurArea = pInArea(x, y)
    If m_iCurArea >= 0 Then
        UserControl.MousePointer = vbCrosshair
        If (Button And 1) Then pCalculateSelector (x)
    Else
        UserControl.MousePointer = vbDefault
    End If
End Sub

Private Sub UserControl_Paint()
    Dim C&, rc As RECT
    For C = 0 To 2
        pFillRect C
        pDrawSelector C
        rc = m_aRc(3)
        InflateRect rc, 1, 1
        FrameRect hdc, rc, GetStockObject(BLACK_BRUSH)
        pDrawPreview False
    Next C
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Dim I&
    I = PropBag.ReadProperty(PRP_COLOR, vbBlue)
    UserControl_Resize
    m_Color = Not I: Color() = I
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty PRP_COLOR, m_Color
End Sub

Private Sub UserControl_Resize()
    Const SPACE& = 10, PREVIEW& = 14: Static iH&, iW&
    Dim dy&, dx&, C&, I&, ish&

    '/ Gre validieren
    ish = UserControl.ScaleHeight
    dy = (ish - MARGIN) \ 3
    If (dy - SPACE) < 5 Then UserControl.Height = UserControl.ScaleY((5 + SPACE) * 3, vbPixels, vbTwips): Exit Sub
    
    dx = UserControl.ScaleWidth
    m_iScaleRange = dx - MARGIN * 3 - PREVIEW
    If m_iScaleRange < 50 Then UserControl.Width = UserControl.ScaleX(50 + MARGIN * 3 + PREVIEW, vbPixels, vbTwips): Exit Sub

    '/ Init Rects
    For C = 0 To 2
        I = dy * C + 1 + MARGIN
        SetRect m_aRc(C), MARGIN, I, m_iScaleRange + MARGIN, I + dy - 2
    Next C
    SetRect m_aRc(3), dx - PREVIEW, 1 + MARGIN, dx - 1 - MARGIN, ish - 8
    
    '/ Positionen der Selektoren neu berechnen
    m_Color = Not m_Color: Color() = Not m_Color
    
    '/ Refresh bei Verkleinerung
    If (iH > ish) Or (iW > dx) Then UserControl.Refresh '._Paint
    iH = ish
    iW = dx
End Sub

Private Sub pInitDIB()
    Dim C&, I&
    C = 256
    Do
        C = C - 1: I = C * 3
        m_aDIB(I + 2) = C
        m_aDIB(I + 1 + 768) = C
        m_aDIB(I + 0 + 1536) = C
    Loop While C
End Sub

Private Sub pFillRect(ByVal I&)
    Dim bih As BITMAPINFOHEADER, hdc&, rc As RECT
    With bih
        .biSize = LenB(bih)
        .biHeight = 3
        .biWidth = 256
        .biPlanes = 1
        .biBitCount = 24
        .biCompression = BI_RGB
    End With
    hdc = UserControl.hdc
    SetStretchBltMode hdc, HALFTONE
    rc = m_aRc(I)
    rc.Bottom = rc.Bottom - 8
    With rc
        StretchDIBits hdc, .Left, .Top, .Right - .Left, .Bottom - .Top, _
            0, I, 256, 1, m_aDIB(0), bih, DIB_RGB_COLORS, vbSrcCopy
    End With
    InflateRect rc, 1, 1
    FrameRect hdc, rc, GetStockObject(BLACK_BRUSH)
End Sub

Private Function pInArea&(ByVal x&, ByVal y&)
    Dim C&
    For C = 0 To 2
        If PtInRect(m_aRc(C), x, y) Then pInArea = C: Exit Function
    Next C
    pInArea = -1
End Function

Private Sub pCalculateSelector(ByVal x)
  '  Dim ipos
    If m_iCurArea >= 0 Then
        pEraseSelector m_iCurArea
        
        '/ neuen Farbwert berechnen
        m_aRGB(m_iCurArea) = Round((255 * (x - MARGIN)) / m_iScaleRange)
        
        '/ neue Position anzeigen
        m_aSelectorPos(m_iCurArea) = (m_iScaleRange * m_aRGB(m_iCurArea)) \ 255
        pDrawSelector m_iCurArea
        
        
        pDrawPreview True
    End If
End Sub

Private Sub pEraseSelector(ByVal id&)
    Dim hdc&, X1&, X2&, Y1&
    '/ alte Position lschen
    X1 = m_aSelectorPos(id)
    hdc = UserControl.hdc
    Y1 = m_aRc(id).Bottom - 7
    If X1 < 8 Then X2 = X1 + 8 Else X2 = X1 - 8
    BitBlt hdc, X1, Y1, 8, 6, hdc, X2, Y1, vbSrcCopy
End Sub

Private Sub pDrawSelector(ByVal id&)
    DrawIconEx UserControl.hdc, m_aSelectorPos(id) + 1, m_aRc(id).Bottom - 7, UserControl.MouseIcon.Handle, 16, 16, 0, 0, DI_NORMAL
End Sub

Private Sub pDrawPreview(ByVal fHalf As Boolean)
    Dim rc As RECT, hBrh&
    hBrh = CreateSolidBrush(RGB(m_aRGB(0), m_aRGB(1), m_aRGB(2)))
    rc = m_aRc(3)
    If fHalf Then rc.Top = rc.Top + (rc.Bottom - rc.Top) \ 2
    FillRect UserControl.hdc, rc, hBrh
    DeleteObject hBrh
End Sub

