VERSION 5.00
Begin VB.UserControl TimeChart 
   CanGetFocus     =   0   'False
   ClientHeight    =   840
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1770
   ClipBehavior    =   0  'None
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   HasDC           =   0   'False
   MousePointer    =   2  'Cross
   ScaleHeight     =   56
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   118
   Windowless      =   -1  'True
   Begin VB.Timer tmrMouseLeave 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   240
      Top             =   240
   End
End
Attribute VB_Name = "TimeChart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'--------------------------------------------------------------------------------------------------------
' Autor        : Guido Beckmann         Email: G.Beckmann@NikoCity.de
' UserControl  : TimeChart (Fensterlos v1.0 2004-2-15)
'                Dieses Steuerelement beruht auf einer Ausschreibung unter http://www.activevb.de
'
' Beschreibung : Es wird ein Liniendiagramm gezeichnet. Die Daten werden eigenstndig aus bestimmten
'                Dateien ermittelt, die sich im Unterordner "/Daten" befinden. Auf der Y-Achse werden
'                Werte im Bereich 0 bis 250000 dargestellt. Die X-Achse spiegelt die letzten 24 Stunden
'                eines vorgegebenen Datums wider. Dabei wird eine Einteilung von 15min verwendet.
'
' Features     - Smtliche Farben sind frei whlbar
'              - Beliebige Schriften fr Skala und Titel
'              - Frei bestimmbarer Maximalwert fr die Y-Achse
'              - Vorgabe eines Titels mit Platzhalter "[d]" fr das Startdatum
'              - Einblendung eines Hinweistextes beim berfliegen mit der Maus
'              - Methoden fr den Druck und Erstellung einer Momentaufnahme
'              - Flickerfrei durch zeichen im Hintergrund
'--------------------------------------------------------------------------------------------------------
Option Explicit

'// Verwendete API-Deklarationen, Typen und Konstanten
Private Declare Function BitBlt& Lib "gdi32" (ByVal hDestDC&, ByVal x&, ByVal y&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal xSrc&, ByVal ySrc&, ByVal dwRop&)
Private Declare Function CreateCompatibleBitmap& Lib "gdi32" (ByVal hdc&, ByVal nWidth&, ByVal nHeight&)
Private Declare Function CreateCompatibleDC& Lib "gdi32" (ByVal hdc&)
Private Declare Function CreateFont& Lib "gdi32" Alias "CreateFontA" (ByVal h&, ByVal w&, ByVal E&, ByVal O&, ByVal w&, ByVal I&, ByVal u&, ByVal s&, ByVal c&, ByVal OP&, ByVal CP&, ByVal Q&, ByVal PAF&, ByVal f As String)
Private Declare Function CreatePen& Lib "gdi32" (ByVal nPenStyle&, ByVal nWidth&, ByVal crColor&)
Private Declare Function CreateRectRgn& Lib "gdi32" (ByVal X1&, ByVal Y1&, ByVal X2&, ByVal Y2&)
Private Declare Function CreateSolidBrush& Lib "gdi32" (ByVal crColor&)
Private Declare Function DeleteDC& Lib "gdi32" (ByVal hdc&)
Private Declare Function DeleteObject& Lib "gdi32" (ByVal hObject&)
Private Declare Function Ellipse& Lib "gdi32" (ByVal hdc&, ByVal X1&, ByVal Y1&, ByVal X2&, ByVal Y2&)
Private Declare Function GetCurrentObject& Lib "gdi32" (ByVal hdc&, ByVal uObjectType&)
Private Declare Function GetDeviceCaps& Lib "gdi32" (ByVal hdc&, ByVal nIndex&)
Private Declare Function GetStockObject& Lib "gdi32" (ByVal nIndex&)
Private Declare Function GetTextExtentPoint32& Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal hdc&, ByVal lpsz As String, ByVal cbString&, lpSize As Any)
Private Declare Function LineTo& Lib "gdi32" (ByVal hdc&, ByVal x&, ByVal y&)
Private Declare Function MoveToEx& Lib "gdi32" (ByVal hdc&, ByVal x&, ByVal y&, lpPoint As Any)
Private Declare Function SelectClipRgn& Lib "gdi32" (ByVal hdc&, ByVal hRgn&)
Private Declare Function SelectObject& Lib "gdi32" (ByVal hdc&, ByVal hObject&)
Private Declare Function SetMapMode& Lib "gdi32" (ByVal hdc&, ByVal nMapMode&)
Private Declare Function SetTextColor& Lib "gdi32" (ByVal hdc&, ByVal crColor&)
Private Declare Function SetViewportExtEx& Lib "gdi32" (ByVal hdc&, ByVal nX&, ByVal nY&, lpSize As Any)
Private Declare Function SetViewportOrgEx& Lib "gdi32" (ByVal hdc&, ByVal nX&, ByVal nY&, lpPoint As Any)
Private Declare Function SetWindowExtEx& Lib "gdi32" (ByVal hdc&, ByVal nX&, ByVal nY&, lpSize As Any)
Private Declare Function SetWindowOrgEx& Lib "gdi32" (ByVal hdc&, ByVal nX&, ByVal nY&, lpPoint As Any)
Private Declare Function TextOut& Lib "gdi32" Alias "TextOutA" (ByVal hdc&, ByVal x&, ByVal y&, ByVal lpString As String, ByVal nCount&)
Private Declare Function DrawText& Lib "user32" Alias "DrawTextA" (ByVal hdc&, ByVal lpStr As String, ByVal nCount&, lpRect As RECT, ByVal wFormat&)
Private Declare Function FillRect& Lib "user32" (ByVal hdc&, lpRect As RECT, ByVal hBrush&)
Private Declare Function FrameRect& Lib "user32" (ByVal hdc&, lpRect As RECT, ByVal hBrush&)
Private Declare Function GetCursorPos& Lib "user32" (lpPoint As POINTAPI)
Private Declare Function GetDC& Lib "user32" (ByVal hwnd&)
Private Declare Function GetSysColor& Lib "user32" (ByVal nIndex&)
Private Declare Function InflateRect& Lib "user32" (lpRect As RECT, ByVal x&, ByVal y&)
Private Declare Function OffsetRect& Lib "user32" (lpRect As RECT, ByVal x&, ByVal y&)
Private Declare Function PtInRect& Lib "user32" (lpRect As RECT, ByVal ptx&, ByVal pty&)
Private Declare Function ReleaseDC& Lib "user32" (ByVal hwnd&, ByVal hdc&)
Private Declare Function ScreenToClient& Lib "user32" (ByVal hwnd&, lpPoint As POINTAPI)
Private Declare Function SetBkColor& Lib "gdi32" (ByVal hdc&, ByVal crColor&)
Private Declare Function SetRect& Lib "user32" (lpRect As RECT, ByVal X1&, ByVal Y1&, ByVal X2&, ByVal Y2&)
Private Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long

Private Type Size
    cx      As Long
    cy      As Long
End Type

Private Type POINTAPI
    x       As Long
    y       As Long
End Type

Private Type RECT
    Left    As Long
    Top     As Long
    Right   As Long
    Bottom  As Long
End Type

Private Const DT_CENTER& = &H1
Private Const DT_RIGHT& = &H2
Private Const DT_VCENTER& = &H4
Private Const DT_SINGLELINE& = &H20
Private Const HORZRES& = 8
Private Const VERTRES& = 10
Private Const LOGPIXELSX& = 88
Private Const LOGPIXELSY& = 90
Private Const PS_SOLID& = 0
Private Const MM_ANISOTROPIC& = 8
Private Const OBJ_PEN& = 1
Private Const OBJ_FONT& = 6
Private Const OBJ_BITMAP& = 7
Private Const OUT_DEFAULT_PRECIS& = 0
Private Const CLIP_DEFAULT_PRECIS& = 0
Private Const DEFAULT_PITCH& = 0
Private Const ANTIALIASED_QUALITY& = 4
Private Const BLACK_BRUSH& = 4



'***************************************************************************************
'* Lokale Daten                                                                       *
'***************************************************************************************

'/ PropertyBag-Keys
Private Const PRP_COLBACK = "c1"
Private Const PRP_COLVERT = "c2"
Private Const PRP_COLHORZ = "c3"
Private Const PRP_COLLINE = "c4"
Private Const PRP_COLTEXT = "c5"
Private Const PRP_FONT = "ft"
Private Const PRP_DATE = "dt"
Private Const PRP_SPACEX = "sx"
Private Const PRP_MAXUSER = "mu"
Private Const PRP_HDRCOL = "c6"
Private Const PRP_HDRTEXT = "ht"
Private Const PRP_HDRFONT = "hf"
Private Const PRP_BORDER = "bd"
Private Const PRP_HINTS = "sh"
Private Const PRP_THICKLINE = "tl"

Private Enum ERefresh                           ' Arten der Grafikerneuerung (siehe Prozedur Refresh)
    erGfx = 0
    erFont = 1
    erBitmap = 2
    erNoUCtlRefresh = 4
End Enum

Private WithEvents m_objFont    As StdFont      ' Schrift fr die Skalen
Attribute m_objFont.VB_VarHelpID = -1
Private m_hFnt                  As Long         ' Zugriffsnummer fr Skalenschriftart mit Antialiasing
Private WithEvents m_objHdrFont As StdFont      ' Schrift fr den Titel
Attribute m_objHdrFont.VB_VarHelpID = -1
Private m_sHdrText              As String       ' Text der berschrift
Private m_iHdrColor             As OLE_COLOR    ' Farbe der berschrift
Private m_iFontColor            As OLE_COLOR    ' Farbe des Skalentextes
Private m_iBackColor            As OLE_COLOR    ' Farbe des Hintergrundes
Private m_iLineColor            As OLE_COLOR    ' Farbe der Wertelinie
Private m_iVerticalLineColor    As OLE_COLOR    ' Farbe der vertikalen Einteilung
Private m_iHorizontalLineColor  As OLE_COLOR    ' Farbe der horizontalen Einteilung
Private m_dtCurrentDate         As Date         ' Startdatum + 24h
Private m_Data(0 To 96)         As Long         ' 97 Werte fr je einen Zeitintervall von 15min
Private m_idxStart              As Long         ' Index fr Startzeit (0->00:00  1->00:15 ...96->23:45)
Private m_iMax                  As Long         ' Maximalwert
Private m_iMaxUser              As Long         ' Maximaler Vorgabewert fr Y-Achse (Bei zu geringer Vorgabe wird der hchste anzuzeigende Wert verwendet.)
Private m_hDC                   As Long         ' Zugriffsnummer des eigenenen Gertekontextes
Private m_hBmpOrg               As Long         ' Zugriffsnummer der ursprnglichen Bitmap
Private m_hFntOrg               As Long         ' Zugriffsnummer der ursprnglichen Schriftart
Private m_BmpWidth              As Long         ' Breite der eigenen Bitmap
Private m_BmpHeight             As Long         ' Hhe der eigenen Bitmap
Private m_DigitSize             As Size         ' Ausmae, Abmessungen einer Ziffer
Private m_GraphX                As Long         ' Position des Nullpunktes in X-Richtung
Private m_GraphY                As Long         ' Position des Nullpunktes in Y-Richtung
Private m_GraphRatio            As Long         ' Verhltnis zwischen Anzahl Pixel und Wertebereich
Private m_iSpacingX             As Long         ' Abstand zwischen Zeitintervallen auf der X-Achse in Pixeln
Private m_fBorder               As Boolean      ' Rahmen zeichnen, ja/nein
Private m_fShowHints            As Boolean      ' Hinweise anzeigen ja/nein
Private m_fNoEvents             As Boolean      ' Ereignisse verarbeiten ja/nein
Private m_iLineThickness        As Long         ' Dicke der Wertelinie

Public Enum EErrTimeChart   ' Fehlernummern des UC's
    errtcPathNotFound = 3
    errtcFileNotFound = vbObjectError + 17000
    errtcFileIsInvalid
    errtcDateIsInvalid
    errtcLineIsInvalid
    errtcValueIsInvalid
    errtcFontSizeIsInvalid
    errtcPrpInvalid
End Enum

Public Event ErrMsg(ByVal Number As EErrTimeChart, Description$)


'***************************************************************************************
'* Eigenschaften                                                                       *
'***************************************************************************************

' BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    BackColor = m_iBackColor
End Property
Public Property Let BackColor(ByVal eBackColor As OLE_COLOR)
    m_iBackColor = eBackColor
    UserControl.PropertyChanged PRP_COLBACK
    UserControl.BackColor = m_iBackColor
    SetBkColor m_hDC, GetColor(m_iBackColor)
    Refresh erGfx
End Property

' Border
Public Property Get Border() As Boolean
Attribute Border.VB_ProcData.VB_Invoke_Property = ";Appearance"
    Border = m_fBorder
End Property
Public Property Let Border(ByVal fBorder As Boolean)
    m_fBorder = fBorder
    UserControl.PropertyChanged PRP_BORDER
    Refresh erGfx
End Property

' CurrentDate
Public Property Get CurrentDate() As Date
Attribute CurrentDate.VB_ProcData.VB_Invoke_Property = ";Misc"
    CurrentDate = m_dtCurrentDate
End Property
Public Property Let CurrentDate(ByVal dtCurrentDate As Date)
    m_dtCurrentDate = dtCurrentDate
    UserControl.PropertyChanged PRP_DATE
    GetValues m_dtCurrentDate
    Refresh erGfx
End Property

' Font
Public Property Get Font() As StdFont
Attribute Font.VB_ProcData.VB_Invoke_Property = ";Font"
    Set Font = m_objFont
End Property
Public Property Set Font(objFont As StdFont)
    If Not m_objFont Is Nothing Then
        Set m_objFont = objFont
        UserControl.PropertyChanged PRP_FONT
        m_objFont_FontChanged "Size"
    End If
End Property

' HeaderColor
Public Property Get HeaderColor() As OLE_COLOR
Attribute HeaderColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    HeaderColor = m_iHdrColor
End Property
Public Property Let HeaderColor(ByVal iHeaderColor As OLE_COLOR)
    m_iHdrColor = iHeaderColor
    Call UserControl.PropertyChanged(PRP_HDRCOL)
    Refresh erGfx
End Property

' HeaderFont
Public Property Get HeaderFont() As StdFont
Attribute HeaderFont.VB_ProcData.VB_Invoke_Property = ";Font"
    Set HeaderFont = m_objHdrFont
End Property
Public Property Set HeaderFont(objHeaderFont As StdFont)
    If Not m_objFont Is Nothing Then
        Set m_objHdrFont = objHeaderFont
        Call UserControl.PropertyChanged(PRP_HDRFONT)
        Refresh erGfx
    End If
End Property

' HeaderText
Public Property Get HeaderText() As String
Attribute HeaderText.VB_ProcData.VB_Invoke_Property = ";Appearance"
    HeaderText = m_sHdrText
End Property
Public Property Let HeaderText(ByVal sHeaderText As String)
    m_sHdrText = sHeaderText
    Call UserControl.PropertyChanged(PRP_HDRTEXT)
    Refresh erGfx
End Property

' HorizontalLineColor
Public Property Get HorizontalLineColor() As OLE_COLOR
Attribute HorizontalLineColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    HorizontalLineColor = m_iHorizontalLineColor
End Property
Public Property Let HorizontalLineColor(ByVal eHorizontalLineColor As OLE_COLOR)
    m_iHorizontalLineColor = eHorizontalLineColor
    UserControl.PropertyChanged PRP_COLHORZ
    Refresh erGfx
End Property

' LineColor
Public Property Get LineColor() As OLE_COLOR
Attribute LineColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    LineColor = m_iLineColor
End Property
Public Property Let LineColor(ByVal eLineColor As OLE_COLOR)
    m_iLineColor = eLineColor
    UserControl.PropertyChanged PRP_COLLINE
    Refresh erGfx
End Property

' LineThickness
Public Property Get LineThickness() As Long
Attribute LineThickness.VB_ProcData.VB_Invoke_Property = ";Appearance"
    LineThickness = m_iLineThickness
End Property
Public Property Let LineThickness(ByVal iLineThickness As Long)
    If iLineThickness <= 0 Then iLineThickness = 1
    If iLineThickness > 10 Then iLineThickness = 10
    m_iLineThickness = iLineThickness
    UserControl.PropertyChanged PRP_THICKLINE
    Refresh erGfx
End Property

' MaxY
Public Property Get MaxY&()
Attribute MaxY.VB_ProcData.VB_Invoke_Property = ";Appearance"
    MaxY = m_iMaxUser
End Property
Public Property Let MaxY(ByVal iMaxY&)
    If iMaxY < 0 Then iMaxY = 0
    If iMaxY > 250000 Then iMaxY = 250000
    m_iMaxUser = iMaxY
    UserControl.PropertyChanged PRP_MAXUSER
    Refresh erGfx
End Property

' ShowHints
Public Property Get ShowHints() As Boolean
Attribute ShowHints.VB_ProcData.VB_Invoke_Property = ";Misc"
    ShowHints = m_fShowHints
End Property
Public Property Let ShowHints(ByVal fShowHints As Boolean)
    m_fShowHints = fShowHints
    UserControl.PropertyChanged PRP_HINTS
End Property

' SpacingX
Public Property Get SpacingX&()
Attribute SpacingX.VB_ProcData.VB_Invoke_Property = ";Appearance"
    SpacingX = m_iSpacingX
End Property
Public Property Let SpacingX(ByVal iSpacingX&)
    If iSpacingX < 2 Then iSpacingX = 2
    If iSpacingX > 8 Then iSpacingX = 8
    m_iSpacingX = iSpacingX
    UserControl.PropertyChanged PRP_SPACEX
    Refresh erBitmap Or erNoUCtlRefresh
    UserControl_Resize
End Property

' TextColor
Public Property Get TextColor() As OLE_COLOR
Attribute TextColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    TextColor = m_iFontColor
End Property
Public Property Let TextColor(ByVal eFontColor As OLE_COLOR)
    m_iFontColor = eFontColor
    UserControl.PropertyChanged PRP_COLTEXT
    Refresh erGfx
End Property

' VerticalLineColor
Public Property Get VerticalLineColor() As OLE_COLOR
Attribute VerticalLineColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
    VerticalLineColor = m_iVerticalLineColor
End Property
Public Property Let VerticalLineColor(ByVal eVerticalLineColor As OLE_COLOR)
    m_iVerticalLineColor = eVerticalLineColor
    UserControl.PropertyChanged PRP_COLVERT
    Refresh erGfx
End Property



'***************************************************************************************
'* Methoden                                                                            *
'***************************************************************************************

Public Function GetProperties() As Byte()   '// Alle Werte serialisieren und bergeben
    Dim pbg As PropertyBag
    Set pbg = New PropertyBag
    pbg.WriteProperty "UC", "TimeChart"
    pbg.WriteProperty "Rev", 1&
    UserControl_WriteProperties pbg
    GetProperties = pbg.Contents
End Function

Public Sub SetProperties(ab() As Byte)      '// Smtliche Eigenschaften aus einem BLOB wieder herstellen
    Dim pbg As PropertyBag, s$, iRev&
    Set pbg = New PropertyBag
    On Error Resume Next
    pbg.Contents = ab()
    On Error GoTo 0
    s = pbg.ReadProperty("UC", vbNullString)
    iRev = pbg.ReadProperty("Rev", 0&)
    If (s = "TimeChart") And (iRev = 1) Then
        UserControl_ReadProperties pbg
        'Refresh erGfx
        UserControl_Resize
    Else
        RaiseEvent ErrMsg(errtcPrpInvalid, "Die Daten der Eigenschaften sind ungltig.")
    End If
End Sub

Public Function GetImage() As StdPicture    '// Snapshot des Diagrammes als COM-StdPicture-Objekt bereit stellen
    UserControl.AutoRedraw = True               ' UserControl eine Bitmap erstellen lassen
    Draw UserControl.hdc                        ' Auf Bitmap des UserControl's zeichnen
    Set GetImage = UserControl.Image            ' StdPicture-Objekt daraus erstellen
    UserControl.AutoRedraw = False              ' Bitmap des Usercontrols vernichten
    Set UserControl.Picture = Nothing
End Function

Public Sub PrintOut()                       '// Diagramm auf dem Standarddrucker ausgeben
    Dim x&, y&, dx&, dy&, hdc&, pbg As PropertyBag, szDPI As Size, szPaper As Size, hFnt&, hRgn&
    
    If Printers.Count = 0 Then Exit Sub
    
    Set pbg = New PropertyBag                   ' Alle Eigenschaften sichern
    UserControl_WriteProperties pbg
    hdc = m_hDC
    
    Printer.Print vbCrLf                        ' Printerobjekt etwas zum "Drucken" geben
    m_hDC = Printer.hdc                         ' Eigenschaften/Variablen setzen
    m_iBackColor = vbWhite
    SetBkColor m_hDC, vbWhite
    hFnt = SelectObject(m_hDC, m_hFnt)
    
    szPaper.cx = GetDeviceCaps(m_hDC, HORZRES)  ' Bedruckbaren Bereich in Pixeln ermitteln (X,Y)
    szPaper.cy = GetDeviceCaps(m_hDC, VERTRES)
    szDPI.cx = GetDeviceCaps(m_hDC, LOGPIXELSX) ' DPI feststellen (X,Y)
    szDPI.cy = GetDeviceCaps(m_hDC, LOGPIXELSY)
    x = 2 * szDPI.cx * 567 \ 1440               ' Anzahl Pixel fr 2cm (X,Y) berechnen
    y = 2 * szDPI.cy * 567 \ 1440
    dx = szPaper.cx - 2 * x                     ' Ausmae nach umlaufenden Rand von ca. 2cm errechnen
    dy = szPaper.cy - 2 * y
    
    SetMapMode m_hDC, MM_ANISOTROPIC            ' Grafik auf bedruckbare Breite zoomen
    SetWindowOrgEx m_hDC, 0, 0, ByVal 0&
    SetWindowExtEx m_hDC, m_BmpWidth, (dy * m_BmpWidth) \ dx, ByVal 0&

    SetViewportOrgEx m_hDC, x, y, ByVal 0&      ' Nullpunkt links oben mit ca. 2cm Rand
    SetViewportExtEx m_hDC, dx, dy, ByVal 0&
    
    hRgn = CreateRectRgn(x, y, x + dx, y + dy)  ' Ausgabebereich einschrnken (fr zu lange berschriften)
    SelectClipRgn m_hDC, hRgn
    DeleteObject hRgn
    
    Draw m_hDC                                  ' Zeichen
    Printer.EndDoc                              ' Ausdrucken

    SelectObject m_hDC, hFnt                    ' Aufrumen
    SelectClipRgn m_hDC, 0&
    Printer.ScaleMode = vbTwips
    m_hDC = hdc                                 ' Eigenschaften wieder herstellen
    UserControl_ReadProperties pbg
End Sub


'***************************************************************************************
'* Ereignisse                                                                          *
'***************************************************************************************

Private Sub m_objFont_FontChanged(ByVal PropertyName As String) '// Skalen-Schriftart hat sich gendert
    If PropertyName = "Size" Then   ' Bei Schriftgrennderung neu zeichnen und UC anpassen
        Refresh erBitmap Or erFont
        UserControl_Resize
    Else
        Refresh erFont ' Schrift aktualisieren und Grafik neu zeichnen
    End If
End Sub

Private Sub m_objHdrFont_FontChanged(ByVal PropertyName As String) '// berschrift wurde verndert
    Refresh erGfx   ' Grafik neu zeichnen
End Sub

Private Sub tmrMouseLeave_Timer()       '// berprfung, ob sich der Mauszeiger noch ber dem UC befindet
    Dim pt As POINTAPI, sm&, rc As RECT
    
    GetCursorPos pt
    ScreenToClient UserControl.ContainerHwnd, pt
    
    sm = Extender.Parent.ScaleMode
    rc.Left = ScaleX(Extender.Left, sm, vbPixels)
    rc.Top = ScaleY(Extender.Top, sm, vbPixels)
    rc.Right = rc.Left + m_BmpWidth
    rc.Bottom = rc.Top + m_BmpHeight

    If PtInRect(rc, pt.x, pt.y) = 0 Then Refresh erGfx
    
    tmrMouseLeave.Enabled = False
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    Static iX&
    Dim idx&, xp&, yp&, s$, I&
    
    If m_fShowHints Then                                        ' Hinweise anzeigen?
        If iX <> CLng(x) Then                                   ' Hat sich die X-Position verndert?
            iX = x                                              ' X-Position fr nchsten Aufruf merken
            idx = (x - m_GraphX) \ m_iSpacingX                  ' Zeitindex errechen und ggf. anpassen
            If idx < 0 Then idx = 0
            If idx > 96 Then idx = 96
            xp = (idx * m_iSpacingX) + m_GraphX                 ' Position der Linie errechnen
            I = m_Data(idx): If I < 0 Then I = 0
            yp = m_GraphY - I \ m_GraphRatio
            Select Case m_Data(idx)                             ' Hinweistext bestimmen
            Case Is >= 0: s = "  Wert: " & m_Data(idx)
            Case -1:    s = "  Kein Wert vorhanden"
            Case -2:    s = "  Datei nicht gefunden"
            Case -3:    s = "  Dateipfad nicht vorhanden"
            Case -4:    s = "  Datei ist defekt"
            Case -5:    s = "  Datum stimmt nicht berein"
            Case -6:    s = "  Ungltiger Wert"
            End Select
            DrawInfo xp, yp, GetTimeStr(m_idxStart + idx) & s   ' Hinweistext einzeichnen
            tmrMouseLeave.Enabled = True                        ' Zeitgeber einschalten
        End If
    End If
End Sub

Private Sub UserControl_Initialize()    '// Initialisierung
    m_hDC = CreateCompatibleDC(0&)                  ' Eigenen Gertekontext erstellen
    m_hBmpOrg = GetCurrentObject(m_hDC, OBJ_BITMAP) ' Originale Bitmap und Zeichensatz merken
    m_hFntOrg = GetCurrentObject(m_hDC, OBJ_FONT)
End Sub

Private Sub UserControl_Terminate()     '// Terminierung
    Dim h&
    
    ' Aufrumen
    Set m_objHdrFont = Nothing
    h = SelectObject(m_hDC, m_hBmpOrg): DeleteObject h
    h = SelectObject(m_hDC, m_hFntOrg): DeleteObject h
    DeleteDC m_hDC
    Set m_objFont = Nothing
End Sub

Private Sub UserControl_Resize()        '// Grennderungen korrigieren
    Dim rh!, sm&
    If m_fNoEvents = False Then ' Roundtrips blokieren
        m_fNoEvents = True
        
        ' UC-Hhe min 100px
        If ScaleHeight < 100 Then rh = 100 Else rh = ScaleHeight
        
        ' Ausmae korrigieren
        sm = Extender.Parent.ScaleMode
        Size ScaleX(CSng(m_BmpWidth), vbPixels, sm), ScaleY(rh, vbPixels, sm)
        
        ' Diagramm neu zeichnen, ggf. Bitmap erneuern
        If ScaleHeight <> m_BmpHeight Then Refresh erBitmap Else Refresh erGfx
        
        ' Schriftgre validieren
        DoEvents
        If (m_DigitSize.cx * 3) > (m_iSpacingX * 8) Then
            RaiseEvent ErrMsg(errtcFontSizeIsInvalid, "Bei einer Zeichensatzgre von " & m_objFont.Size & " kann die X-Achse nicht korrekt dargestellt werden.")
        End If
        
        m_fNoEvents = False
    End If
End Sub

Private Sub UserControl_Show()      '// Das Steuerelement wird angezeigt
    GetValues m_dtCurrentDate           ' Werte fr vorgegebenes Datum ermitteln
    Refresh erGfx                       ' und Anzeigen
End Sub


Private Sub UserControl_InitProperties() '// Steuerelement wird neu angelegt, Variablen initialisieren
    m_iBackColor = vbWhite
    UserControl.BackColor = m_iBackColor
    m_iVerticalLineColor = &HC0C0C0
    m_iHorizontalLineColor = &HE0E0E0
    m_iFontColor = vbBlack
    m_iLineColor = vbBlue
    m_dtCurrentDate = Now
    Set m_objFont = New StdFont
    m_iSpacingX = 5
    m_iMaxUser = 0
    Set m_objHdrFont = New StdFont
    m_sHdrText = "[d]"
    m_iHdrColor = vbBlue
    m_fBorder = True
    m_fShowHints = True
    m_iLineThickness = 1
    
    GetValues m_dtCurrentDate
    Refresh erBitmap Or erFont Or erNoUCtlRefresh
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag) '// Persistente Eigenschaften wieder herstellen
    m_iBackColor = PropBag.ReadProperty(PRP_COLBACK, vbWhite)
    UserControl.BackColor = m_iBackColor
    m_iVerticalLineColor = PropBag.ReadProperty(PRP_COLVERT, &HC0C0C0)
    m_iHorizontalLineColor = PropBag.ReadProperty(PRP_COLHORZ, &HE0E0E0)
    m_iLineColor = PropBag.ReadProperty(PRP_COLLINE, vbBlue)
    m_iFontColor = PropBag.ReadProperty(PRP_COLTEXT, vbBlack)
    Set m_objFont = PropBag.ReadProperty(PRP_FONT, New StdFont)
    m_dtCurrentDate = PropBag.ReadProperty(PRP_DATE, Now)
    m_iSpacingX = PropBag.ReadProperty(PRP_SPACEX, 5)
    m_iMaxUser = PropBag.ReadProperty(PRP_MAXUSER, 0)
    m_iHdrColor = PropBag.ReadProperty(PRP_HDRCOL, vbBlue)
    m_sHdrText = PropBag.ReadProperty(PRP_HDRTEXT, "[d]")
    Set m_objHdrFont = PropBag.ReadProperty(PRP_HDRFONT, New StdFont)
    m_fBorder = PropBag.ReadProperty(PRP_BORDER, True)
    m_fShowHints = PropBag.ReadProperty(PRP_HINTS, True)
    m_iLineThickness = PropBag.ReadProperty(PRP_THICKLINE, 1)

    GetValues m_dtCurrentDate
    Refresh erBitmap Or erFont Or erNoUCtlRefresh
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag) '// Eigenschaften sichern
    PropBag.WriteProperty PRP_COLBACK, m_iBackColor
    PropBag.WriteProperty PRP_COLVERT, m_iVerticalLineColor
    PropBag.WriteProperty PRP_COLHORZ, m_iHorizontalLineColor
    PropBag.WriteProperty PRP_COLLINE, m_iLineColor
    PropBag.WriteProperty PRP_COLTEXT, m_iFontColor
    PropBag.WriteProperty PRP_DATE, m_dtCurrentDate
    PropBag.WriteProperty PRP_FONT, m_objFont
    PropBag.WriteProperty PRP_SPACEX, m_iSpacingX
    PropBag.WriteProperty PRP_MAXUSER, m_iMaxUser
    PropBag.WriteProperty PRP_HDRCOL, m_iHdrColor
    PropBag.WriteProperty PRP_HDRTEXT, m_sHdrText
    PropBag.WriteProperty PRP_HDRFONT, m_objHdrFont
    PropBag.WriteProperty PRP_BORDER, m_fBorder
    PropBag.WriteProperty PRP_HINTS, m_fShowHints
    PropBag.WriteProperty PRP_THICKLINE, m_iLineThickness
End Sub

Private Sub UserControl_Paint() '// Teile des Steuerelementes mssen neu gezeichnet werden
     BitBlt UserControl.hdc, 0, 0, m_BmpWidth, m_BmpHeight, m_hDC, 0, 0, vbSrcCopy
End Sub




'***************************************************************************************
'* Lokale Funktionen                                                                   *
'***************************************************************************************


'---------------------------------------------------------------------------------------
' Prozedur : ReadFile
' Aufgabe  : Die Prozedur bildet aus einem Datumswert den Dateinamen, liest diese Datei
'            ein und wertet dessen Inhalt aus.
'---------------------------------------------------------------------------------------
Private Sub ReadFile(ByVal dateFile As Date, ResultLng&())
    Dim sFileName   As String   ' Dateiname
    Dim abData()    As Byte     ' Datei-Daten
    Dim hFile       As Integer  ' Datei-Nummer
    Dim nrType      As Long     ' Zahlentyp: 0=Zahl, 1->Datum, 2->Zeit
    Dim LastTimeIdx As Long     ' Letzter errechneter Zeitindex: 7:00->28, 7:15->29 ...
    Dim nr          As Long     ' Aktuell ermittelter Zahlenwert
    Dim ai(2)       As Long     ' Zahlentyp-Gruppen: 13:45-> ai(0)=13, ai(1)=45
    Dim iCur        As Long     ' Aktuelle Zahlentypgruppe
    Dim line        As Long     ' Aktuelle Zeile
    Dim c           As Long     ' Schleifenzhler
    
    
    '/ Initialisierung
    ReDim ResultLng(0 To 95)                    ' Ein Tag hat max. 96 Werte
    For c = 0 To 95: ResultLng(c) = -1: Next c  '-1 bedeutet im Diagram "kein Wert vorhanden".
    line = 1                                    ' Zeile in Datei fr eventuelle Fehlerausgabe
    
    '/ Dateinamen zusammen setzen
    sFileName = App.Path
    If Right$(sFileName, 1) <> "\" Then sFileName = sFileName & "\"
    sFileName = sFileName & "daten\" & Format$(dateFile, "yyyymmdd") & ".txt"

    '/ Pfad/Datei prfen
    c = GetFileAttributes(sFileName)
    If c = -1 Then
        Select Case Err.LastDllError
        Case 2
            Err.Clear
            RaiseEvent ErrMsg(errtcFileNotFound, "Die Datei """ & sFileName & """ existiert nicht.")
            For c = 0 To 95: ResultLng(c) = -2: Next c  '-2 bedeutet im Diagram "Datei nicht vorhanden".
            Exit Sub
        Case 3
            Err.Clear
            RaiseEvent ErrMsg(errtcPathNotFound, "Der Pfad """ & sFileName & """ existiert nicht.")
            For c = 0 To 95: ResultLng(c) = -3: Next c  '-3 bedeutet im Diagram "Pfad nicht vorhanden".
            Exit Sub
        End Select
    End If
    
    '/ Datei ffnen, Daten einlesen
    hFile = FreeFile()
    Open sFileName For Binary Access Read As #hFile
        ReDim abData(0 To LOF(hFile) - 1)
        Get #hFile, , abData()
    Close #hFile
    
    '/ Daten validieren und auswerten
    For c = 0 To UBound(abData())
        Select Case abData(c) ' Aktuelles Zeichen (ASCII) untersuchen
        Case 48 To 57   ' Ziffer
            If nr >= 0 Then nr = nr * 10 + abData(c) - 48
            If nr > 250000 Then
                RaiseEvent ErrMsg(errtcValueIsInvalid, "Zeile " & CStr(line) & " der Datei """ & sFileName & """ enthlt einen ungltigen Wert.")
                nr = -6
            End If
        Case 58         ' ":" -> Zahlentyp ist eine Uhrzeit
            nrType = 2
            ai(iCur) = nr
            nr = 0
            If iCur < 2 Then iCur = iCur + 1
        Case 46         ' "." -> Zahlentyp ist ein Datum
            nrType = 1
            ai(iCur) = nr
            nr = 0
            If iCur < 2 Then iCur = iCur + 1
        Case 32         ' " " -> Zahlentyp ist ein anzuzeigender Wert
            ai(iCur) = nr
            GoSub check
            nrType = 0
        Case 13         ' CR - Neue Zeile
            ai(iCur) = nr
            GoSub check
            line = line + 1
            nrType = -1
        Case Is > 32
            RaiseEvent ErrMsg(errtcFileIsInvalid, "Die Datei """ & sFileName & """ ist defekt.")
            For nr = 0 To 95: ResultLng(nr) = -4: Next nr  '-4 bedeutet im Diagram "Datei ist defekt".
            Exit Sub
        End Select
    Next c
    ai(iCur) = nr
    GoSub check
    Exit Sub

check:
    Select Case nrType
    Case 0  ' Wert in Ergebnismenge eintragen
        If (LastTimeIdx >= 0) Then ResultLng(LastTimeIdx) = ai(0)
    Case 1  ' Datum prfen
        If Int(dateFile) <> DateSerial(ai(2), ai(1), ai(0)) Then
            RaiseEvent ErrMsg(errtcDateIsInvalid, "Das Datum der Datei """ & sFileName & """ stimmt nicht berein.")
            For nr = 0 To 95: ResultLng(nr) = -5: Next nr  '-5 bedeutet im Diagram "Datum stimmt nicht berein".
            Exit Sub
        End If
    Case 2  ' Zeit prfen
        If (ai(0) > 23) Or (ai(1) > 59) Then
            RaiseEvent ErrMsg(errtcLineIsInvalid, "Zeile " & CStr(line) & " der Datei """ & sFileName & """ ist fehlerhaft.")
            LastTimeIdx = -1
        Else
            LastTimeIdx = (ai(0) * 4) + (ai(1) \ 15)
        End If
    End Select
    iCur = 0
    nr = 0
    Return
End Sub


'---------------------------------------------------------------------------------------
' Prozedur : GetValues
' Aufgabe  : Ermittelt alle anzuzeigenden Werte fr das vorgegebene Datum.
'            - Die Ergebnismenge wird im Datenfeld "m_Data" hinterlegt.
'            - Der maximale Wert wird bestimmt (m_iMax).
'            - Der Index fr die Startzeit wird in m_idxStart aufbewahrt.
'---------------------------------------------------------------------------------------
Private Sub GetValues(dtDate As Date)
    Dim aiNow&(), aiYesterday&(), dt As Date, c&, d&
    
    dt = Int(dtDate)                ' Uhrzeit entfernen (Nachkommastellen abschneiden)
    ReadFile dt, aiNow()            ' Datei fr aktuellen Tag einlesen
    ReadFile dt - 1#, aiYesterday() ' Datei fr vorherigen Tag einlesen
    
    '/ Startzeitpunkt errechnen
    ' 1.Nachkommastellen extrahieren (Dies ist die Uhrzeit eines Date-Datentypes: 0.5 -> 12:00h)
    ' 2.Multiplizieren mit Minuten je Tag (24*60min = 1440min)
    ' 3.Dividieren durch anzuzeigende Zeitspanne (15min)
    m_idxStart = ((dtDate - dt) * 1440) \ 15
    
    For c = m_idxStart To 95        ' Es werden 97 Werte (24h/0,25h+1) fr die Darstellung
        m_Data(d) = aiYesterday(c)  ' bentigt.
        d = d + 1                   ' Diese werden aus den ermittelten Werten der 2 einge-
    Next c                          ' lesenen Tage ins Datenfeld "m_Data" umkopiert.
    For c = 0 To m_idxStart Mod 96
        m_Data(d) = aiNow(c)
        d = d + 1
    Next c
    
    m_iMax = m_Data(0)              ' Maximalwert fr Diagrammanzeige suchen
    For c = 1 To 96
        If m_Data(c) > m_iMax Then m_iMax = m_Data(c)
    Next c
End Sub

Private Function GetColor&(ByVal col&)  '// Bei vorkommenden Systemfarben den RGB-Farbwert ermitteln
    If col < 0 Then GetColor = GetSysColor(col And &HFF&) Else GetColor = col
End Function

Private Function GetHalfColor&(ByVal col1&, ByVal col2&)    '// Das Mittel zwischen zwei Farben ermitteln
    Dim c&                                                  '   (fr vertikale Linien xx:15 - xx:45)
    col1 = GetColor(col1)
    col2 = GetColor(col2)

    For c = 0 To 2
        GetHalfColor = GetHalfColor Or ((((col1 And &HFF&) + (col2 And &HFF&)) \ 2) * &H100 ^ c)
        col1 = col1 \ &H100
        col2 = col2 \ &H100
    Next c
End Function

Private Function GetTimeStr$(ByVal idx&) '// Liefert fr einen Zeitabschnitt (0-95) die Uhrzeit im Format "hh:mm"
    idx = idx Mod 96
    GetTimeStr = Right$("0" & CStr(idx \ 4) & ":", 3) & Right$("0" & CStr(15 * (idx Mod 4)), 2)
End Function

Private Sub Refresh(ByVal er As ERefresh) '// Das Diagramm wird nach Parametervorgabe erneuert und/oder angezeigt
    If (er And erBitmap) <> 0 Then CreateCanvas     ' Bei Bedarf (Grennderung) die Bitmap neu erstellen
    If (er And erFont) <> 0 Then CreateFnt          ' Bei Bedarf neuen Zeichensatz erstellen
    
    If (er And erNoUCtlRefresh) = 0 Then            ' Eventuell nicht neu zeichnen
        Draw m_hDC
        If UserControl.Ambient.UserMode Then UserControl_Paint Else UserControl.Refresh
    End If
End Sub

Private Sub CreateFnt()     '// Zeichensatz mit Antialiasing erstellen
    Dim hFnt&
    
    With m_objFont
        m_hFnt = CreateFont(-(.Size * GetDeviceCaps(m_hDC, LOGPIXELSY)) \ 72, 0, 0, 0, 400 - 300 * .Bold, _
                           .Italic, .Underline, .Strikethrough, .Charset, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY, DEFAULT_PITCH, .Name)
    End With
    hFnt = SelectObject(m_hDC, m_hFnt)              ' Neue Schrift selektieren
    If hFnt <> m_hFntOrg Then DeleteObject hFnt     ' nicht mehr verwendete Schrift lschen
    GetTextExtentPoint32 m_hDC, "0", 1, m_DigitSize ' Ausmae einer Ziffer ermitteln

End Sub

Private Sub CreateCanvas()     '// Eigene Bitmap erstellen, um im Hintergrund zu zeichnen
    Dim hdc&, hBmp&, hFnt&, fnt As IFont
    
    hdc = GetDC(0)                                              ' Desktop-DC ausleihen
    
    Set fnt = m_objFont                                         ' Ausmae einer Ziffer ermitteln
    hFnt = SelectObject(hdc, fnt.hFont)
    GetTextExtentPoint32 hdc, "0", 1, m_DigitSize
    SelectObject hdc, hFnt

    m_BmpHeight = UserControl.ScaleHeight                       ' Ausmae der Bitmap bestimmen
    m_BmpWidth = 7 * m_DigitSize.cx + 97 * m_iSpacingX + 10
    hBmp = CreateCompatibleBitmap(hdc, m_BmpWidth, m_BmpHeight) ' Neue Bitmap erzeugen
    ReleaseDC 0, hdc                                            ' Desktop-DC zurckgeben
    
    hBmp = SelectObject(m_hDC, hBmp)                            ' Neue Bitmap selektieren
    If hBmp <> m_hBmpOrg Then DeleteObject hBmp                 ' nicht mehr gebrauchte Bitmap lschen
End Sub

Private Sub Draw(ByVal hdc&)    '// Die Prozedur zeichnet das komplette Diagramm gegen einen Gertekontext
    Dim s$, dx&, dy&, c&, hFnt&, hPen1&, hPen2&, hPenOrg&, hBrush&, rc As RECT
    Dim iTitleHeight&, aSplitY&(3), iSplitY&, fUp As Boolean, sz As Size, hdcTmp&
    
    '/ Hintergrund lschen
    hBrush = CreateSolidBrush(GetColor(m_iBackColor))   ' Pinsel erzeugen
    SetRect rc, 0, 0, m_BmpWidth, m_BmpHeight           ' Zu "bermalendes" Rechteck festlegen
    FillRect hdc, rc, hBrush                            ' Ausmalen
    DeleteObject hBrush                                 ' Aufrumen
    
    SetBkColor hdc, GetColor(m_iBackColor)              ' Hintergrundfarbe setzen
    m_GraphX = m_DigitSize.cx * 7                       ' Nullpunkt-X berechnen
    dx = m_GraphX
    
    '/ berschrift zeichnen
    If Len(m_sHdrText) Then                             ' Kein Text, keine berschrift
        SetTextColor hdc, GetColor(m_iHdrColor)         ' Textfarbe setzen
        
        s = Format$(m_dtCurrentDate - 1, "Medium Date") & " " & GetTimeStr(m_idxStart)
        s = Replace(m_sHdrText, "[d]", s)               ' berschriftentext ggf. um das Startdatum erweitern
        
        hdcTmp = GetDC(0&)                              ' Schrift fr berschrift erzeugen
        With m_objHdrFont
            hFnt = CreateFont(-(.Size * GetDeviceCaps(hdcTmp, LOGPIXELSY)) \ 72, 0, 0, 0, 400 - 300 * .Bold, _
                              .Italic, .Underline, .Strikethrough, .Charset, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, ANTIALIASED_QUALITY, DEFAULT_PITCH, .Name)
        End With
        SelectObject hdc, hFnt                          ' Schrift selektieren
        TextOut hdc, m_GraphX, 5, s, Len(s)             ' Text ausgeben
        
        hFnt = SelectObject(hdcTmp, hFnt)               ' Ausmae einer Ziffer ermitteln
        GetTextExtentPoint32 hdcTmp, "0", 1, sz
        iTitleHeight = sz.cy + 10                       ' Platzbedarf fr berschrift ermitteln
        hFnt = SelectObject(hdcTmp, hFnt)
        
        ReleaseDC 0&, hdcTmp                            ' Aufrumen
        SelectObject hdc, m_hFnt
        DeleteObject hFnt
        
    Else
        iTitleHeight = m_DigitSize.cy \ 2 + 2           ' Platzbedarf fr berschrift errechnen
    End If
    
    m_GraphY = m_BmpHeight - m_DigitSize.cy - 8         ' Nullpunkt-Y berechnen
    dy = m_GraphY - iTitleHeight
    
    SetTextColor hdc, GetColor(m_iFontColor)            ' Textfarbe setzen
    
    

    '/ Vertikale Linien zeichnen
    hPen1 = CreatePen(PS_SOLID, 1, GetColor(m_iVerticalLineColor))
    hPen2 = CreatePen(PS_SOLID, 1, GetHalfColor(m_iBackColor, m_iVerticalLineColor))
    hPenOrg = GetCurrentObject(hdc, OBJ_PEN)            ' neue Stifte erzeugen & akt. Stift ermitteln
    
    For c = m_idxStart To m_idxStart + 96               ' von links nach rechts
        MoveToEx hdc, dx, iTitleHeight, ByVal 0&        ' Stift auf oberen Punkt absetzen
        If c Mod 4 Then                                 ' Auf volle Stunde prfen
            SelectObject hdc, hPen2                     ' Keine volle Stunde, dann
            LineTo hdc, dx, m_GraphY + 4                ' eine Line mit Stift 2 zeichnen
        Else
            SelectObject hdc, hPen1                     ' Bei voller Stunde eine Line
            LineTo hdc, dx, m_GraphY + 6                ' mit Stift 1 zeichnen
            If (c And 4) = 0 Then                       ' Beschriftung der X-Achse (Jede 2te Stunde)
                SetRect rc, dx - m_DigitSize.cx * 2, m_GraphY + 6, dx + m_DigitSize.cx * 2, m_GraphY + 14 + m_DigitSize.cy
                s = CStr((c \ 4) Mod 24) & "h"
                DrawText hdc, s, Len(s), rc, DT_CENTER Or DT_SINGLELINE
            End If
        End If
        dx = dx + m_iSpacingX                           ' Nchste Linie
    Next c
    
    SelectObject hdc, hPenOrg                           ' Aufrumen
    DeleteObject hPen1
    DeleteObject hPen2
    
    '/ Einteilung ermitteln (Ein- oder Zehnfaches von 5, 10, 20 oder 25)
    If m_iMax > m_iMaxUser Then c = m_iMax Else c = m_iMaxUser
    m_GraphRatio = c \ dy + 1
    aSplitY(0) = 5
    aSplitY(1) = 10
    aSplitY(2) = 20
    aSplitY(3) = 25
    Do
        For c = 0 To 3
            iSplitY = aSplitY(c)
            If iSplitY > ((m_DigitSize.cy + 5) * m_GraphRatio) Then Exit Do
            aSplitY(c) = aSplitY(c) * 10
        Next c
    Loop
    
    '/ Horizonzale Linien zeichnen
    hPen1 = CreatePen(PS_SOLID, 1, GetColor(m_iHorizontalLineColor))
    SelectObject hdc, hPen1                             ' Stift erzeugen u. selektieren
    
    dx = dx - m_iSpacingX
    For c = 0 To (m_GraphRatio * dy) \ iSplitY          ' Von unten nach oben
        dy = m_GraphY - (iSplitY * c) \ m_GraphRatio    'Y-Position errechnen
        MoveToEx hdc, m_GraphX, dy, ByVal 0&            ' Line zeichen
        LineTo hdc, dx, dy
        
        s = CStr(c * iSplitY)                           ' Beschriftung einzeichnen
        SetRect rc, 0, dy - m_DigitSize.cy, m_GraphX - 2, dy + m_DigitSize.cy
        DrawText hdc, s, Len(s), rc, DT_RIGHT Or DT_SINGLELINE Or DT_VCENTER
    Next c                                              ' Nchste Line
    
    SelectObject hdc, hPenOrg                           ' Aufrumen
    DeleteObject hPen1
    
    '/ Werte einzeichnen
    hPen1 = CreatePen(PS_SOLID, m_iLineThickness, GetColor(m_iLineColor))
    SelectObject hdc, hPen1                             ' Stift erzeugen u. selektieren
    
    dx = m_GraphX                                       ' dx auf Nullpunkt setzen
    fUp = True                                          ' Stift ist oben
    
    For c = 0 To 96                                     ' Von links nach rechts
        If m_Data(c) < 0 Then                           ' Wert vorhanden?
            fUp = True                                  ' Nein, Stift nach oben
        Else
            dy = m_GraphY - m_Data(c) \ m_GraphRatio    ' Ja, Y-Position errechnen
            If fUp Then                                 ' Wenn Stift oben,
                MoveToEx hdc, dx, dy, ByVal 0&          ' dann Stift nach unten,
                fUp = False
            Else                                        ' ansonsten Line weiterziehen.
                LineTo hdc, dx, dy
            End If
        End If
        dx = dx + m_iSpacingX                           ' Nchste X-Position
    Next c
    SelectObject hdc, hPenOrg                           ' Aufrumen
    DeleteObject hPen1
    
    '/ Rahmen zeichnen
    If m_fBorder Then
        SetRect rc, 0, 0, m_BmpWidth, m_BmpHeight       ' Ausmae der Umrandung festlegen
        hBrush = CreateSolidBrush(vbBlack)              ' Pinsel erzeugen
        FrameRect hdc, rc, hBrush                       ' Rahmen zeichnen
        DeleteObject hBrush                             ' Aufrumen
    End If
End Sub

Private Sub DrawInfo(ByVal x&, ByVal y&, sText$)    '// Hinweis fr selektierten Wert zeichnen
    Dim rc As RECT, dx&, dy&, hBr&, hFnt&, fnt As IFont

    Draw m_hDC                                                              ' neu zeichen
    Set fnt = UserControl.Font                                              ' Zeichensatz selektieren
    hFnt = SelectObject(m_hDC, fnt.hFont)
    GetTextExtentPoint32 m_hDC, sText, Len(sText), ByVal VarPtr(rc) + 8     ' Text-Ausmae ermitteln
    
    '/ Gre und Position des umgebenden Rechteckes festlegen
    InflateRect rc, 3, 1
    dx = rc.Right + 10
    If (x + dx + 10) > m_BmpWidth Then dx = x - dx Else dx = x + 10
    dy = y + rc.Bottom \ 2
    If (dy + rc.Bottom + 5) > m_BmpHeight Then dy = dy - rc.Bottom
    OffsetRect rc, dx, dy
        
    '/ Zeichen
    hBr = CreateSolidBrush(GetColor(SystemColorConstants.vbInfoBackground)) ' Hintergrund
    FillRect m_hDC, rc, hBr
    DeleteObject hBr
    InflateRect rc, 1, 1
    FrameRect m_hDC, rc, GetStockObject(BLACK_BRUSH)                        ' Rahmen
    SetBkColor m_hDC, GetColor(SystemColorConstants.vbInfoBackground)       ' Text
    SetTextColor m_hDC, GetColor(SystemColorConstants.vbInfoText)
    DrawText m_hDC, sText, Len(sText), rc, DT_SINGLELINE Or DT_VCENTER Or DT_CENTER
    dx = (m_iLineThickness + 1) \ 2 + 2                                     ' Kreis
    Ellipse m_hDC, x - dx, y - dx, x + dx, y + dx
    
    ' Aufrumen und Anzeigen
    SelectObject m_hDC, hFnt
    If UserControl.Ambient.UserMode Then UserControl_Paint Else UserControl.Refresh
End Sub

