VERSION 5.00
Begin VB.Form frmHaupt 
   Caption         =   "Liniendiagramm"
   ClientHeight    =   6120
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   9750
   LinkTopic       =   "Form1"
   ScaleHeight     =   6120
   ScaleWidth      =   9750
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdDiagrammErstellen 
      Caption         =   "Diagramm &erstellen"
      Height          =   375
      Left            =   7920
      TabIndex        =   1
      Top             =   5280
      Width           =   1695
   End
   Begin VB.PictureBox picDiagramm 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00FFFFFF&
      Height          =   5055
      Left            =   120
      ScaleHeight     =   333
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   629
      TabIndex        =   0
      Top             =   120
      Width           =   9495
   End
End
Attribute VB_Name = "frmHaupt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' /////////////////////////////////////////////////////////////////////////////
' //
' // Liniendiagramm: frmHaupt <frmHaupt.frm>
' //
' //
' //
' // Lsung fr die ActiveVB.de-Ausschreibung zum Thema "Liniendiagramm er-
' // stellen".
' // Siehe Kommentierung und info.txt fr weitere Informationen.
' //
' // Autor: Marc Ermshaus <marcermshaus@aol.com>
' // Datum: 20.02.2004
' //
' /////////////////////////////////////////////////////////////////////////////

Option Explicit

' /////////////////////////////////////////////////////////////////////////////
' vordefinierte Eigenschaften

' Farben
Private Const COL_ACHSE  As Long = &H0&     'Schwarz
Private Const COL_GITTER As Long = &HC0C0C0 'Grau
Private Const COL_LINIE  As Long = &HFF     'Rot

' Zeichenstile
Private Const DS_ACHSE  As Integer = 0 'Solid
Private Const DS_GITTER As Integer = 2 'Dash
Private Const DS_LINIE  As Integer = 0 'Solid

' Abstnde der effektiven Zeichenflche
Private DG_DLEFT   As Integer 'Variable wird zweckentfremdet
Private DG_DTOP    As Integer
Private DG_DRIGHT  As Integer
Private DG_DBOTTOM As Integer

' /////////////////////////////////////////////////////////////////////////////
' lokale Variablen

Private mEnde As Integer
Private mStart As Integer
Private mMax As Long
Private mWerte(0 To 95) As Long 'Enthlt die anzuzeigenden Diagrammwerte fr
                                '96 mal 15 Minuten (entspricht der Zeitspanne
                                'eines Tages).
  
' /////////////////////////////////////////////////////////////////////////////
' ZeitStrZuBruchteil(ZeitStr As String) As Integer
' BruchteilZuZeitStr(Bruchteil As Integer) As String
' -----------------------------------------------------------------------------
'   - ZeitStr: Zeichenkette entsprechend der Zeitstempel der einzulesenden Da-
'       dateien (z. B. "16:45")
'   - Bruchteil: Sechsundneunzigstel eines Tages
'
' Intern wird der Tag in 96 Teile aufgeteilt, die den entsprechenden Eintrgen
' in den auszulesenden Dateien entsprechen. Teil 0 entspricht der Zeit 00:00,
' Teil 1 der Zeit "00:15" usw. bis Teil 95, der 23:45 entspricht.
' Die vorliegenden beiden Funktionen wandeln das eine Format ins jeweilige an-
' dere um.
'
' - Die Funktionen berprfen die bergebenen Werte nicht auf ihre Richtigkeit!
' /////////////////////////////////////////////////////////////////////////////
Private Function ZeitStrZuBruchteil(ZeitStr As String) As Integer
    ZeitStrZuBruchteil = CStr(CInt(Left(ZeitStr, 2)) * 4 + _
      Right(ZeitStr, 2) \ 15)
End Function

Private Function BruchteilZuZeitStr(Bruchteil As Integer) As String
    BruchteilZuZeitStr = Replace(Format(CStr(Bruchteil \ 4), "00") & ":" & _
      Format(CStr((Bruchteil Mod 4) * 15), "00"), "24", "00")
End Function
  
' /////////////////////////////////////////////////////////////////////////////
' DateiVonDatum(Datum As Date) As String
' -----------------------------------------------------------------------------
'   - Datum: ein beliebiges Datum
'
' Formt das bergebene Datum in einen Dateinamen des Typs "yyyymmdd.txt" um.
' /////////////////////////////////////////////////////////////////////////////
Private Function DateiVonDatum(Datum As Date) As String
    DateiVonDatum = CStr(Year(Datum)) & _
      Format$(CStr(Month(Datum)), "00") & _
      Format$(CStr(Day(Datum)), "00") & ".txt"
End Function

' /////////////////////////////////////////////////////////////////////////////
' DateiParsen(ByVal Datei As String, ByVal IndexStart As Integer, _
'   ByVal IndexEnde As Integer, ByVal FeldIndexStart As Integer)
' -----------------------------------------------------------------------------
'   - Datei: Dateipfad zur einzulesenden Datei
'   - IndexStart: erste auszulesende Zeit in Bruchteilen
'   - IndexEnde: letzte auszulesende Zeit in Bruchteilen
'   - FeldIndexStart: "Zeiger" auf den Index von <mWerte>, der den ersten Da-
'       tensatz aufnehmen soll
'
' Liest die Werte des angegebenen Zeitraums (in Bruchteilen anzugeben) aus und
' schreibt sie ab dem angegebenen Index in <mWerte>.
'
' - Die Funktion besteht haargenau auf das in der Aufgabenstellung dargelegte
'   Format. Es wird ab der dritten Zeile gelesen, leere Zeilen werden ber-
'   sprungen, Zeilen mit Inhalt werden als passend formatiert ("hh:mm Wert")
'   angenommen. Eine explizite berprfung oder Fehlerkorrektur findet nicht
'   statt!
' /////////////////////////////////////////////////////////////////////////////
Private Sub DateiParsen(ByVal Datei As String, ByVal IndexStart As Integer, _
  ByVal IndexEnde As Integer, ByVal FeldIndexStart As Integer)
  
    Dim iDateiNr As Long
    Dim i As Integer
    Dim sBuffer As String
    Dim sZeitStr As String 'Zeitstempel der aktuellen Zeile
    Dim sAnzahl As String 'Wert der aktuellen Zeile
    Dim iBruchteil As Integer
    
    i = 0
    iDateiNr = FreeFile()
    
    Open Datei For Input As iDateiNr
        Do Until EOF(iDateiNr)
            i = i + 1
            Line Input #iDateiNr, sBuffer
            ' Ab Spalte drei mit der Auswertung beginnen
            If i > 2 And Trim(sBuffer) <> "" Then
                ' Zeile ist nicht leer und wird als passend formatiert
                ' angenommen
                sZeitStr = Left(sBuffer, 5)
                sAnzahl = Right(sBuffer, Len(sBuffer) - InStrRev(sBuffer, " "))
                iBruchteil = ZeitStrZuBruchteil(sZeitStr)
                If iBruchteil >= IndexStart And iBruchteil <= IndexEnde Then
                    ' Aktueller Zeitindex fllt in den auszulesenden Bereich
                    
                    ' Maximalwert nebenbei ermitteln
                    If CLng(sAnzahl) > mMax Then mMax = CLng(sAnzahl)
                    
                    ' Wert ins Feld bernehmen
                    mWerte(FeldIndexStart + (iBruchteil - IndexStart)) = _
                      CLng(sAnzahl)
                End If
            End If
        Loop
    Close iDateiNr
End Sub

' /////////////////////////////////////////////////////////////////////////////
' WerteEinlesen(Optional ByVal Datum As Date = vbNull)
' -----------------------------------------------------------------------------
'   - Datum: Ende (!) der darzustellenden Zeitspanne
'
' Liest die darzustellenden Diagrammwerte der 24 Stunden vor dem bergebenen
' Datum ein und speichert sie in der lokalen Variable <mWerte>.
'
' - Wird kein Datum (bzw. vbNull) bergeben, nimmt die Prozedur das aktuelle
'   Datum an.
' /////////////////////////////////////////////////////////////////////////////
Private Sub WerteEinlesen(Optional ByVal Datum As Date = vbNull)
    Dim sDateipfad As String
    Dim sDateiname1 As String 'Dateiname der Datei von heute
    Dim sDateiname2 As String 'Dateiname der Datei von gestern
    Dim i As Integer
    
    ' Falls Datum nicht gesetzt, aktuelles Datum annehmen
    If Datum = vbNull Then Datum = Now
    
    ' Pfade bestimmen
    sDateipfad = Replace$(App.Path & "\Daten", "\\", "\")
    sDateiname1 = DateiVonDatum(Datum)
    sDateiname2 = DateiVonDatum(DateAdd("d", -1, Now))
    
    ' End- und Startbruchteil ermitteln (ist "15:39" die bergebene Zeit, wird
    ' als Endbruchteil beispielsweise 63 ermittelt)
    mEnde = (Hour(Datum) * 60 + Minute(Datum)) \ 15
    ' Daten in die passende Grenordnung pressen
    mStart = mEnde + 1
    'If mStart = 96 Then mStart = 0
    
    ' Werte zurcksetzen (-1 bedeutet anschaulich "Wert nicht gefunden")
    For i = 0 To 95
        mWerte(i) = -1
    Next i
    
    mMax = -1
    
    ' * Daten einlesen. Sollte eine Datei nicht vorhanden sein, bleiben die
    ' * entsprechenden Werte auf -1 ("nicht gesetzt")
    ' *
    ' * Es mssen immer zwei Dateien ausgelesen werden auer wenn es zwischen
    ' * 23:45:00 und 23:59:59 Uhr ist
    
    If Dir(sDateipfad & "\" & sDateiname1) <> "" Then
        ' Heutigen Anteil laden und an entsprechende Stelle von <mWerte> ein-
        ' fgen
        DateiParsen sDateipfad & "\" & sDateiname1, 0, mEnde, 96 - mStart
    End If
    
    ' Sollte <mStart> den Wert 96 besitzen, muss nur die heutige Datei ausgele-
    ' sen werden, da die Uhrzeit 23:44:59 < x < 00:00:00 betrgt
    If mStart <> 96 Then
        If Dir(sDateipfad & "\" & sDateiname2) <> "" Then
            ' Gestrigen Anteil laden und an entsprechende Stelle von <mWerte> ein-
            ' fgen
            DateiParsen sDateipfad & "\" & sDateiname2, mStart, 95, 0
        End If
    End If
End Sub

' /////////////////////////////////////////////////////////////////////////////
' ErmittleSkalaMaximum(Maximum As Long) As Long
' -----------------------------------------------------------------------------
'   - Maximum: grte zu zeichnende Zahl
'
' Bildet den nchsthheren ganzzahligen Wert der ersten beiden Ziffer von
' <Maximum> und fllt die restlichen Stellen mit Nullen auf.
'
' - Zahlen unter 100 werden als 100 zurckgegeben.
' - Die Funktion ist fr den gesamten Long-Bereich anwendbar.
' /////////////////////////////////////////////////////////////////////////////
Private Function ErmittleSkalaMaximum(Maximum As Long) As Long
    Dim iStellen As Integer
    Dim x As Integer

    If Maximum < 100 Then
        ErmittleSkalaMaximum = 100
        Exit Function
    End If

    iStellen = Len(CStr(Maximum))
    x = CInt(Left(CStr(Maximum), 2))
    If x Mod 2 = 0 Then x = x + 2 Else x = x + 1
    ErmittleSkalaMaximum = x * 10 ^ (iStellen - 2)
End Function

' /////////////////////////////////////////////////////////////////////////////
' *** DEBUG: Diese Funktion fr eine grobere Skala einkommentieren.
'
' ErmittleSkalaMaximum(Maximum As Long) As Long
' -----------------------------------------------------------------------------
'   - Maximum: grte zu zeichnende Zahl
'
' Bildet die nchsthhere Zehnerpotenz zu <Maximum>.
'
' - Zahlen unter 100 werden als 100 zurckgegeben.
' - Die Funktion ist fr den gesamten Long-Bereich anwendbar.
' /////////////////////////////////////////////////////////////////////////////
'Private Function ErmittleSkalaMaximum(Maximum As Long) As Long
'    If Maximum < 100 Then
'        ErmittleSkalaMaximum = 100
'    Else
'        ErmittleSkalaMaximum = 10 ^ (Len(CStr(Maximum)))
'    End If
'End Function

' /////////////////////////////////////////////////////////////////////////////
' DiagrammZeichnen()
' -----------------------------------------------------------------------------
'
' Diese Prozedur bernimmt den kompletten Zeichenvorgang des Diagramms der ein-
' gelesenen Werte.
' /////////////////////////////////////////////////////////////////////////////
Private Sub DiagrammZeichnen()
    Dim iHeight As Integer 'Hhe der gesamten Steuerelementskalierung
    Dim iWidth As Integer 'dazugehrige Breite
    Dim sStep As Single 'Abstand der einzelnen Werte auf der Zeichenflche
    Dim iCurX As Integer '
    Dim iCurY As Integer '
    Dim x1 As Integer    ' Hilfsvariablen
    Dim x2 As Integer    '
    Dim y1 As Integer    '
    Dim y2 As Integer    '
    Dim i As Integer
    Dim sMax As Integer 'Hhe der effektiven Zeichenflche
    
    iHeight = picDiagramm.ScaleHeight
    iWidth = picDiagramm.ScaleWidth
    
    ' * Optimalste Skala ermitteln
    mMax = ErmittleSkalaMaximum(mMax) 'Achtung! <mMax> wird berschrieben und
                                      'fr andere Zwecke unbrauchbar

    ' * Autoanpassen
    DG_DLEFT = picDiagramm.TextWidth(String(Len(CStr(mMax)), "8")) + 15
      ' Achtung! Auch <DG_DLEFT> wird an dieser Stelle zweckentfremdet, indem
      ' die Variable den Wert einen Wert enthlt, der es erlaubt, die Skala
      ' in jedem Fall sichtbar neben das Diagramm zu schreiben
    
    sMax = iHeight - (DG_DTOP + DG_DBOTTOM)
    
    ' * Werte einzeichnen
    With picDiagramm
        .ForeColor = COL_LINIE
        .DrawStyle = DS_LINIE
    End With
    
    sStep = (iWidth - (DG_DLEFT + DG_DRIGHT)) / 96
    
    ' Bei jedem Schleifendurchlauf werden zwei Werte eingezeichnet, um eine
    ' Linie ziehen zu knnen
    For i = 0 To 94
        ' Wert 1 in Beziehung zur Zeichenflche setzen
        x1 = CLng(DG_DLEFT + i * sStep)
        y1 = CLng(DG_DTOP + sMax - (mWerte(i) / mMax) * sMax)
        
        ' Wert 2 in Beziehung zur Zeichenflche setzen
        x2 = CLng(DG_DLEFT + (i + 1) * sStep)
        y2 = CLng(DG_DTOP + sMax - (mWerte(i + 1) / mMax) * sMax)
        
        If mWerte(i) = -1 Or mWerte(i + 1) = -1 Then
            ' Isolierte Werte (d. h. Werte ohne direkten Nachbarn) als Kreuz
            ' einzeichnen
            If mWerte(i) <> -1 Then
                ' Wert vorhanden
                
                ' Wenn linker Nachbar vorhanden, dann kein Kreuz setzen
                If i = 0 Then
                    picDiagramm.Line (x1 - 2, y1)-(x1 + 3, y1)
                    picDiagramm.Line (x1, y1 - 2)-(x1, y1 + 3)
                Else
                    If mWerte(i - 1) = -1 Then
                        picDiagramm.Line (x1 - 2, y1)-(x1 + 3, y1)
                        picDiagramm.Line (x1, y1 - 2)-(x1, y1 + 3)
                    End If
                End If
            End If
            
            ' Sonderfall: Falls der letze Wert isoliert ist (dessen Index wird
            ' nicht direkt bearbeitet), diesen ebenfalls als Kreuz einzeichnen
            If i = 94 And mWerte(i) = -1 And mWerte(i + 1) <> -1 Then
                picDiagramm.Line (x2 - 2, y2)-(x2 + 3, y2)
                picDiagramm.Line (x2, y2 - 2)-(x2, y2 + 3)
            End If
        Else
            ' Nicht isolierte Werte als Wertepaar (Linie) einzeichnen
            picDiagramm.Line (x1, y1)-(x2, y2)
        End If
    Next i
    
    ' * Achsen einzeichnen
    With picDiagramm
        .ForeColor = COL_ACHSE
        .DrawStyle = DS_ACHSE
    End With
    
    picDiagramm.Line (DG_DLEFT, DG_DTOP)-(DG_DLEFT, iHeight - DG_DBOTTOM + 10)
    picDiagramm.Line (DG_DLEFT - 10, iHeight - DG_DBOTTOM)- _
      (iWidth - DG_DRIGHT, iHeight - DG_DBOTTOM)
    
    ' * Skala einzeichnen
        
    ' * Y-Achse
    For i = 0 To 4
        x1 = DG_DLEFT - 5
        y1 = CLng(DG_DTOP + i / 5 * sMax)
        x2 = DG_DLEFT + 5
        y2 = y1
        
        ' gestrichelte horizontale Linie
        With picDiagramm
            .ForeColor = COL_GITTER
            .DrawStyle = DS_GITTER
        End With
        picDiagramm.Line (x1 + 5, y1)-(iWidth - DG_DRIGHT, y2)
    
        ' Linien auf der Achse
        With picDiagramm
            .ForeColor = COL_ACHSE
            .DrawStyle = DS_ACHSE
        End With
        
        picDiagramm.Line (x1, y1)-(x2, y2)
        picDiagramm.CurrentX = x1 - DG_DLEFT + 10
        picDiagramm.CurrentY = y1 - picDiagramm.TextHeight("1234567890") \ 2
        picDiagramm.Print CStr(mMax * (4 - i + 1) \ 5)
    Next i
        
    ' * X-Achse
    With picDiagramm
        .ForeColor = COL_ACHSE
        .DrawStyle = DS_ACHSE
    End With
    For i = 0 To 12
        x1 = CLng(DG_DLEFT + i * sStep * 4 * 2)
        y1 = iHeight - (DG_DBOTTOM - 5)
        x2 = x1
        y2 = iHeight - (DG_DBOTTOM + 5)
        picDiagramm.Line (x1, y1)-(x2, y2)
        
        ' Entsprechenden Bruchteil (in Relation zu den in <mStart> und <mEnde>
        ' definierten Start- und Endwerte des Lesevorgangs) ermitteln und in
        ' Zeitstempel umwandeln (Zahlen grer als 96 entsprechend reduzieren)
        If mStart + i * 8 > 96 Then
            picDiagramm.CurrentX = x1 - (picDiagramm.TextWidth( _
              BruchteilZuZeitStr(mStart + i * 8 - 96)) \ 2)
            picDiagramm.CurrentY = y1 + 5
            picDiagramm.Print BruchteilZuZeitStr(mStart + i * 8 - 96)
        Else
            picDiagramm.CurrentX = x1 - (picDiagramm.TextWidth( _
              BruchteilZuZeitStr(mStart + i * 8)) \ 2)
            picDiagramm.CurrentY = y1 + 5
            picDiagramm.Print BruchteilZuZeitStr(mStart + i * 8)
        End If
    Next i
End Sub

Private Sub cmdDiagrammErstellen_Click()
    Dim DebugDate As Date
    
    ' *** DEBUG: Zu Testzwecken andere Daten auswhlen
    DebugDate = CVDate("2004-03-01 10:00:00")
    'WerteEinlesen DebugDate
        
    WerteEinlesen
    DiagrammZeichnen
End Sub

Private Sub Form_Load()
    ' Pseudo-Kostanten mit Standardwerten fllen
    DG_DLEFT = 5
    DG_DTOP = 10
    DG_DRIGHT = 20
    DG_DBOTTOM = 25
End Sub
