VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDiagramm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Dim arrWerte(0 To 97) As Long       'Fr die Werte aus der Datei
    'In diesem Array werden alle Wert gespeichert,
    'die aus den Dateien geladen werden.
    'Dabei ist der Index immer ein 15-Minuten-Schritt,
    'd.h. 0=00:00, 1=00:15, 2=00:30, 3=00:45, 4=01:00, usw.
Dim sDatum As String                'Das Datum, welches oben drber steht
    'In dieser Variable wird gespeichert, welches Datum geladen wird.
Dim lZeitUmbruch As Long      'Zeitpunkt zu dem der umbruch zwischen 'heute' und 'gestern' ist
    'Wenn z.B. die Werte von "heute" nur bis 15:00 Uhr gehen,
    'werden die Werte von 00:00 bis 15:00 aus der "heute"-Datei geholt,
    'und die Werte von 15:00 bis 24:00 aus der Datei des vorherigen Tages.
    'In dieser Variable wird gespeichert, zu welchem Zeitpunkt dieser
    '"Umbruch" ist. Dabei wird nicht 15:00 sondern z.B. 60 gespeichert,
    'da 15:00 in dem Array (arrWerte) die Stelle 60 hat.
Dim lMaxWert As Long                'Der hchste im Array vorhandene Wert
    'In dieser Variable wird der hchste Wert der im Array arrWerte gespeichert.
    '(wichtig fr die Skalierung)
Dim picDiagramm As PictureBox       'Picture-Box fr die Ausgabe
    'Auf diesem Objekt vom Typ PictureBox wird das Diagramm gezeichnet.
Dim lXScale As Long                 'X-Skalierung
    'Hier wird gespeichert, wie gro die Schritte zwischen den vertikalen
    'Hilfslinien sind. -> X-Skalierung
    'Standartweise immer 8 ( x 15 Minuten ), also alle 2 Std.
Dim lYScale As Long                 'Y-Skalierung
    'Hier wird gespeichert, wie gro die Schritte zwischen den horizontalen
    'Hilfslinien sind. -> Y-Skalierung
    'Der Wert wird von der Funktion DrawYScale auf Wunsch auch automatisch gewhlt.
    'In diesem Fall sind es immer Werte wie 10, 100, 1000, 10000 oder 20,  200,  2000

'Die folgenden Variablen knnen auch ausserhalb der Klasse gesetzt werden.
'Beispiel: Diagramm.lGraphColor = vbRed
'Sie stellen die Farben dar, mit denen das Diagramm gezeichnet wird
Public lScaleXLinesColor As Long    'Farbe der horizontalen Linien
Public lScaleXValuesColor As Long   'Farbe der Beschriftung der horizontalen Linien
Public lScaleYLinesColor As Long    'Farbe der vertikalen Linien
Public lScaleYValuesColor As Long   'Farbe der Beschriftung der vertikalen Linien
Public lGraphColor As Long          'Farbe des Graphen
Public lBackgroundColor As Long     'Farbe des Hintergrundes



' * * * Ldt und zeichnet das Diagramm * * *
Public Sub DiagrammLadenUndZeichnen(ByVal Datum As String, ByVal Uhrzeit As String)
'Diese Funktion braucht nur aufgerufen zu werden. (nachdem das Ausgabe-Objekt gesetzt ist)
'Sie ldt alle Daten zum angegebenen Datum und Uhrzeit
'und stellt Sie diese sofort auf dem Ausgabe-Objekt dar.

  Dim n As Long             'Fehler-Index
    'Einige Funktionen geben einen Fehler-Index zurck,
    'wenn sie nicht korrekt ausgefhrt werden konnten
  Dim dVorDatum As Date     'Das Datum vom vorherigem Tag
    'Um 24 Std. darstellen zu knnen, muss auch der vorherige Tag
    'geladen werden.
    'Das Datum von "gestern" wird hiermit ermittelt
    
    On Error GoTo Fehler
    'Wenn Fehler auftreten (z.B. File not found),
    'wird die Funktion abgebrochen, und eine Fehlermeldung
    'wird angezeigt
    
    'Das Datum vom vorherigem Tag berechnen
    dVorDatum = Datum           '"Heute"
    dVorDatum = dVorDatum - 1   '"Heute" - 1 = "Gestern"
    
    'Den 'Zeit-Umbruch' in eine Zahl 0-96 umrechnen
    'd.h. 0=00:00, 1=00:15, 2=00:30, 3=00:45, 4=01:00, usw.
    lZeitUmbruch = UhrzeitToScale(Uhrzeit)
    'Die Funktion UhrzeitToScale in dieser Klasse rechnet Strings im Format hh:mm
    'in eine solche Zahl um.
    
    'Datei laden
    n = Me.LoadFile(App.Path & "\" & Format(Datum, "yyyyMMdd") & ".txt", _
                          App.Path & "\" & Format(dVorDatum, "yyyyMMdd") & ".txt")
    'Die Funktion LoadFile ldt die beiden angegeben Datein (heute und gestern)
    'und wertet aus, welche Werte von "heute" und welche von "gestern" sein mssen
               
    'Wenn kein Fehler aufgetreten
    If n = 0 Then
        
        'Diagramm zeichnen
        Me.DrawDiagram True
        'Der Parameter True bedeutet, dass die Funktion selber die Skalierung whlt
        
    Else
        'Wenn Fehler beim Datei-Laden aufgetreten
        If n = 53 Then
            'File not found
            MsgBox "Fehler: Datei nicht vorhanden", vbCritical, "Fehler"
        Else
            'Unbekannter Fehler
            MsgBox "Unbekannter Fehler", vbCritical, "Fehler"
        End If
    End If

'Wenn irgend ein anderer Fehler auftritt, einfach eine Meldung anzeigen
Exit Sub
Fehler:
    MsgBox "Unbekannter Fehler", vbCritical, "Fehler"
End Sub

' * * * Diese Funktion zeichnet das Diagramm * * *
Public Sub DrawDiagram(ByVal AutoScale As Boolean)
'Wird aufgerufen, wenn die Werte bereits geladen sind.
'Wahlweise kann diese Funktion die Skalierung automatisch whlen (AutoScale = True)

  Dim lArrayPosition As Long    'Die Position im Array fr lStunden:lMinuten
    
    'Altes Diagramm lschen
    picDiagramm.Cls
    'Hintergrundfarbe setzen
    picDiagramm.BackColor = lBackgroundColor
    'Skalierung (Horizontal in 15-Minuten-Schritten, Vertikal in Prozent)
    picDiagramm.Scale (-8, 105)-(99, -5)
    'd.h. 0 auf der X-Achse entspricht 00:00, 96 = 24:00
    'auf der Y-Achse ist 0 = 0 und 100 = lMaxWert (also der hchste Wert in arrWerte)
    
    'Horizontale Hilfslinien zeichnen
    DrawYScale AutoScale
    'Vertikale Hilfslinien zeichnen
    DrawXScale AutoScale
    'Diese Funktionen knnen die Skalierung automtisch whlen
    
    'Den Graphen mit einer dicken Linie zeichnen
    picDiagramm.DrawWidth = 2
    
    'Wenn der 0te Wert vorhanden ist, aber nicht der 1te, dann einfach eine vertikale Linie zeichnen
    If arrWerte(0) <> -1 And arrWerte(1) = -1 Then
        picDiagramm.Line (96 - lZeitUmbruch, arrWerte(0) / lMaxWert * 100)- _
                        (96 - lZeitUmbruch, 0), lGraphColor
    End If
    'Diese Extra-Abfrage ist ntig, da in der Schleife sonst auf ein -1. Element zugegriffen wrde
    
    'Alle Punkte durchgehen
    For lArrayPosition = 1 To 95
    
        If arrWerte(lArrayPosition) <> -1 And arrWerte(lArrayPosition - 1) <> -1 Then
            'Wenn vorher ein gltiger Wert vorhanden war
            
            If lArrayPosition - 1 = lZeitUmbruch Then
                'Hier ist der bergang der beiden Tage
                ' - ganz am Anfang des Diagramms und ganz am Ende
                '   deshalb nichts zeichnen
            ElseIf lArrayPosition > lZeitUmbruch Then
                'Wenn bei gestrigem Tag gerade gezeichnet wird ...
                picDiagramm.Line (lArrayPosition - 2 - lZeitUmbruch, arrWerte(lArrayPosition) / lMaxWert * 100)- _
                        (lArrayPosition - 3 - lZeitUmbruch, arrWerte(lArrayPosition - 1) / lMaxWert * 100), lGraphColor
            Else
                'Wenn bei heutigem Tag gerade gezeichnet wird ...
                picDiagramm.Line (lArrayPosition + (96 - lZeitUmbruch), arrWerte(lArrayPosition) / lMaxWert * 100)- _
                        (lArrayPosition - 1 + (96 - lZeitUmbruch), arrWerte(lArrayPosition - 1) / lMaxWert * 100), lGraphColor
            End If
            
        ElseIf arrWerte(lArrayPosition + 1) = -1 And _
               arrWerte(lArrayPosition) <> -1 And _
               arrWerte(lArrayPosition - 1) = -1 Then
            'Wenn verher und nachher keine gltigen Werte sind,
            'einfach eine vertikale Linie zeichnen
            'Knnte auch in einen Punkt oder in sonst was gendert werden
            
            If lArrayPosition - 1 = lZeitUmbruch Then
                'Hier ist der bergang der beiden Tage
                ' - ganz am Anfang des Diagramms und ganz am Ende
                '   deshalb nichts zeichnen
            ElseIf lArrayPosition > lZeitUmbruch Then
                'Wenn bei gestrigem Tag gerade gezeichnet wird ...
                picDiagramm.Line (lArrayPosition - 2 - lZeitUmbruch, arrWerte(lArrayPosition) / lMaxWert * 100)- _
                        (lArrayPosition - 2 - lZeitUmbruch, arrWerte(lArrayPosition) / lMaxWert * 100), lGraphColor
            Else
                'Wenn bei heutigem Tag gerade gezeichnet wird ...
                picDiagramm.Line (lArrayPosition + (96 - lZeitUmbruch), arrWerte(lArrayPosition) / lMaxWert * 100)- _
                        (lArrayPosition + (96 - lZeitUmbruch), 0), lGraphColor
            End If
        End If
        'Nchstes Stck der Linie
    Next lArrayPosition
    
    'Wenn der 96te Wert vorhanden ist ....
    If arrWerte(96) <> -1 Then
        'und der 95te auch
        If arrWerte(95) <> -1 Then
            'dann ganz normal das letzte Stck zeichnen
            picDiagramm.Line (95 - lZeitUmbruch, arrWerte(96) / lMaxWert * 100)- _
                        (93 - lZeitUmbruch, arrWerte(95) / lMaxWert * 100), lGraphColor
        Else
            'Wenn der 95te Wert fehlt, ein vertikale Linie zeichen
            picDiagramm.Line (95 - lZeitUmbruch, arrWerte(96) / lMaxWert * 100)- _
                             (95 - lZeitUmbruch, 0), lGraphColor
        End If
    End If
    'Dieser Teil ist ntig, da in der Schleife sonst auf ein 97tes Element zugegriffen wrde
    
    'Verbindung zwischen 23:45 und 00:00
    If arrWerte(96) <> -1 And arrWerte(0) <> -1 Then
        'Wenn beide Wert vorhanden, dann verbinden
            picDiagramm.Line (96 - lZeitUmbruch, arrWerte(0) / lMaxWert * 100)- _
                             (95 - lZeitUmbruch, arrWerte(96) / lMaxWert * 100), lGraphColor
    End If
    'Ist ntig, da der bergang zwischen den beiden Tagen irgendwo in der
    'Mitte des Diagramms ist.
    
    'Alles anzeigen
    picDiagramm.Refresh
End Sub

' * * * Whlt die vertikale Skalierung und zeichnet die Linien und die Beschriftung * * *
Private Function DrawXScale(ByVal AutoScale As Boolean)
'Zeichnet die Vertikalen Hilfslinien
'Wenn AutoScale = True, wird die Skalierung automatisch gewhlt

  Dim n As Long                 'Zhler
  Dim sZeit As String           'Die umgerechnete Zeit (0 - 96) -> (00:00 - 23:45)
                                'Fr die Beschriftungen

    'Vertikale Hilfslinien-Skalierung
    If AutoScale Then
        lXScale = 8     '8 x 15 Minuten = 2 Std
                        'd.h. alle 2 Std eine Linie
    End If
        
    'vertikale Hilfslinien zeichnen
    'Geht alle Hilfslinien durch
    For n = 0 To 96 Step lXScale
        'Linie zeichnen
        picDiagramm.Line (n, 0)-(n, 102), lScaleYLinesColor
        'Beschriftung
        If n > 97 - lZeitUmbruch Then
            'Wenn bei heutigem Tag
            sZeit = Format(Str(Int((n + lZeitUmbruch - 96) / 4)), "00") & ":" _
                    & Format(Str(((n + lZeitUmbruch - 96) Mod 4) * 15), "00")
            '0-96 wird zu 00:00-24:00
        Else
            'Wenn bei gestrigem Tag
            sZeit = Format(Str(Int((n + lZeitUmbruch) / 4)), "00") & ":" _
                    & Format(Str(((n + lZeitUmbruch) Mod 4) * 15), "00")
            '0-96 wird zu 00:00-24:00
        End If
        'Position fr Beschriftung
        picDiagramm.CurrentX = n - (picDiagramm.TextWidth(sZeit) / 2)
        picDiagramm.CurrentY = 0
        'Farbe fr Beschriftung
        picDiagramm.ForeColor = lScaleYValuesColor
        'Beschriften
        picDiagramm.Print sZeit
    'Nchste Linie
    Next n
    
End Function

' * * * Whlt die horizontale Skalierung und zeichnet die Linien und die Beschriftung * * *
Private Function DrawYScale(ByVal AutoScale As Boolean)
'Zeichnet die horizontalen Hilfslinien
'Wenn AutoScale = True, wird die Skalierung automatisch gewhlt
    
  Dim n As Long                 'Zhler
  
    'Horizontale Hilfslinien-Skalierung
    If AutoScale Then
        lYScale = 10 ^ (Len(Trim(Str(lMaxWert))) - 1)
        'macht z.B. aus 5874 -> 1000
        If Int(lMaxWert / lYScale) = 1 Then
            'Wenn nur eine Linie gezeichnet wrde,
            'Skalierung verkleinern
            lYScale = lYScale / 5
            'd.h. z.B. bei lMaxWert = 1124 -> 1000 -> 200 (wren 5 statt 1 Linien)
        End If
    End If
    
    'Dnne Linien zeichnen
    picDiagramm.DrawWidth = 1
    
    'ein paar horizontale Hilfslinien zeichnen
    'Geht alle zu zeichnenden Linien durch
    For n = 0 To lMaxWert Step lYScale
        'Linie zeichnen
        picDiagramm.Line (0, n / lMaxWert * 100)- _
                         (96, n / lMaxWert * 100), lScaleXLinesColor
        'Position der Beschriftung
        picDiagramm.CurrentX = 0 - picDiagramm.TextWidth(Str(n) & " ")
        picDiagramm.CurrentY = n / lMaxWert * 100 - (picDiagramm.TextHeight(Str(n)) / 2)
        'Farbe der Beschriftung
        picDiagramm.ForeColor = lScaleXValuesColor
        'Beschriftung
        picDiagramm.Print n
    'Nchste Linie
    Next n
End Function

' * * * Diese Funktion ldt die beiden angegeben Datein (heute und gestern) * * *
Public Function LoadFile(ByVal FileName As String, ByVal VorDatumFileName As String) As Long
'Die Funktion LoadFile ldt die beiden angegeben Datein (heute und gestern)
'und wertet aus, welche Werte von "heute" und welche von "gestern" sein mssen
    
  Dim n As Long                 'Fehler-Index
    'Einige Funktionen geben einen Fehler-Index zurck,
    'wenn sie nicht korrekt ausgefhrt werden konnten
  Dim lArrayPosition As Long    'Die Position im Array fr lStunden:lMinuten
  
    On Error GoTo Fehler
    'Wenn Fehler auftreten (z.B. File not found),
    'wird die Funktion abgebrochen und gibt den
    'Fehler-Index zurck
    
    'Alle fehlenden Eintrge haben den Wert -1
    For lArrayPosition = 0 To 96
        arrWerte(lArrayPosition) = -1
    Next lArrayPosition
    
    'Hchsten Wert zurcksetzen
    lMaxWert = 0
    
    'Werte laden vom heutigen Tag
    n = WerteLaden(FileName, False)
    'Fehler zurckgeben, wenn der Tag nicht da ist.
    If n <> 0 Then Err.Raise n
    
    'Werte laden vom gestrigen Tag
    n = WerteLaden(VorDatumFileName, True)
    'Macht nix, wenn der VorTag nicht da ist, Fehler verwerfen
    
    '0 Zurckgeben, wenn Funktionsaufruf erfolgreich
    LoadFile = 0

'Bei irgendeinem Fehler, den Fehler-Index zurckgeben
Exit Function
Fehler:
    'Fehlernummer zurckgeben
    LoadFile = Err.Number
End Function

' * * * Diese Funktion wandelt Strings im Format hh:mm in den entsprechenden Index im arrWerte um * * *
Private Function UhrzeitToScale(ByVal Uhrzeit As Variant) As Long
    UhrzeitToScale = Int(Left(Trim(Format(Uhrzeit, "hh:mm")), 2)) * 4 + Int(Mid(Trim(Format(Uhrzeit, "hh:mm")), 4, 2) / 15)
End Function

' * * * Diese Funktion holt die Werte aus der Datei * * *
Private Function WerteLaden(ByVal FileName As String, ByVal GesternHeute As Boolean) As Long
'Der Parameter GesternHeute ist dazu da, damit die Funktion auswerten kann,
'ob ein Wert geladen werden muss, oder ob dieser aus der anderen (gestern oder heute)
'Datei geladen werden muss.

  Dim sInput As String          'Zeile aus der Datei
  Dim lStunden As Long          'Stunden (von der Zeit)
  Dim lMinuten As Long          'Minuten (von der Zeit)
  Dim lArrayPosition As Long    'Die Position im Array fr lStunden:lMinuten
                                'd.h. UhrzeitToScale(lStunden:lMinuten)

    On Error GoTo Fehler
    'Wenn Fehler auftreten (z.B. File not found),
    'wird die Funktion abgebrochen und gibt den
    'Fehler-Index zurck
    
    'Datei ffnen
    Open FileName For Input As #1

    'Datei laden
    'Alle Zeilen der Datei durchgehen
    Do Until EOF(1)
        'Zeile einlesen
        Line Input #1, sInput
        
        'Auswertung, was die Zeile enthlt
        If Mid(sInput, 3, 1) = "." And Mid(sInput, 6, 1) = "." Then
            'Wenn die Zeile das Datum enthlt
            sDatum = sInput
        ElseIf Trim(sInput) = "" Then
            'Wenn die Zeile nichts enthlt
            '(dann passiert auch nix)
        ElseIf Mid(sInput, 3, 1) = ":" And Mid(sInput, 6, 1) = " " Then
            'Wenn die Zeile eine Uhrzeit enthlt
            'Stunden ermitteln
            lStunden = Val(Mid(sInput, 1, 2))
            'Minuten ermitteln
            lMinuten = Val(Mid(sInput, 4, 2))
            'Ist die Zeit spter als die Aktuelle, muss die Zeit aus der Gestern-Datei geholt werden
            'Ansonsten aus der Heutigen
            If (UhrzeitToScale(lStunden & ":" & lMinuten) > lZeitUmbruch) = GesternHeute Then
                'Platz im Array ermitteln
                lArrayPosition = lStunden * 4 + lMinuten / 15
                'Steht eine Zahl hinter der Uhrzeit?
                If Len(sInput) > 6 Then
                    If lArrayPosition > lZeitUmbruch Then lArrayPosition = lArrayPosition + 1
                    'Den Wert an der entsprechenden Position im Array speichern
                    arrWerte(lArrayPosition) = Val(Trim(Mid(sInput, 7)))
                    'Hchsten Wert ermitteln
                    If arrWerte(lArrayPosition) > lMaxWert Then lMaxWert = arrWerte(lArrayPosition)
                End If
            End If
        End If
    Loop
    
    'Datei schlieen
    Close #1
    
    '0 Zurckgeben, wenn Funktionsaufruf erfolgreich
    WerteLaden = 0
    
Exit Function
Fehler:
    'Fehlernummer zurckgeben
    WerteLaden = Err.Number
End Function

' * * * Let/Get XScale (Horizontale Skalierung) * * *
Public Property Let XScale(ByRef NewValue As Long)
    lXScale = NewValue
End Property
Public Property Get XScale() As Long
    XScale = lXScale
End Property

' * * * Let/Get YScale (Vertikale Skalierung) * * *
Public Property Let YScale(ByRef NewValue As Long)
    lYScale = NewValue
End Property
Public Property Get YScale() As Long
    YScale = lYScale
End Property

' * * * Auf diesem Objekt wird das Diagramm ausgegeben * * *
Public Property Set picAusgabe(ByRef picNewValue As PictureBox)
'Muss eine PictureBox sein
'Nur Set (kein Get)
'Muss ALS ERSTES gesetzt werden
    Set picDiagramm = picNewValue
End Property

' * * * Klassen - Initialisierung * * *
Private Sub Class_Initialize()
'Standart-Farben setzen
    lScaleXLinesColor = RGB(127, 127, 127)
    lScaleXValuesColor = vbBlack
    lScaleYLinesColor = RGB(127, 127, 127)
    lScaleYValuesColor = vbBlack
    lGraphColor = vbBlue
    lBackgroundColor = vbWhite
End Sub
