Attribute VB_Name = "Diagramm"
Public Filename As String
Public Points(10000) As WertPaarType   'WertPaarType
Public Lines As Integer   'Diagrammlinien

Type WertPaarType
  Uhrzeit As String
  Wert As Double
  Linie As String
End Type

Sub Laden(Optional Hinzufgen As Boolean, Optional Von As String, Optional Bis As String)
  On Error Resume Next
  
  'Wenn Daten hinzufgen
  If Hinzufgen = True Then
    For i = 1 To UBound(Points)
      If Points(i).Uhrzeit = "" Then
        Position = i
        Exit For
      End If
    Next
    If Position > 0 Then
      i = Position - 1
    Else
      i = 0
    End If
  End If
  
  'Datei laden
  Open Filename For Input As #1
  Line Input #1, Datum  'Datum auslesen
  Do
    Line Input #1, WertPaar
    'Wenn keine leere Zeile
    If InStr(WertPaar, " ") > 0 Then
      'Wenn bereich eingehalten wird, ...
      Dim bVon As Boolean
      bVon = CDate(Von) <= CDate(Mid$(WertPaar, 1, 5))
      Dim bBis As Boolean
      bBis = CDate(Bis) >= CDate(Mid$(WertPaar, 1, 5))
      
      If bVon And bBis Then
        i = i + 1
        Points(i).Uhrzeit = Mid$(WertPaar, 1, 5)
        Points(i).Wert = Mid$(WertPaar, 7, Len(WertPaar) - 6)
        Points(i).Linie = Lines
      End If
    End If
  Loop Until EOF(1)
  Close #1
End Sub

Sub Zeichnen()
  Hilflinien  'Skalierung, Hilflinien, usw. zeichnen
  
  If frmmain.cmdLiniendiagramm.FontUnderline = True Then
    LinienDiagramm    'Linien Diagramm zeichnen
  Else
    SulenDiagramm    'Sulen Diagramm zeichnen
  End If
End Sub

Sub Hilflinien()
  On Error Resume Next
  'Senkrechte Linie
  frmmain.picDiagramm.Line (15, 5)-(15, frmmain.picDiagramm.ScaleHeight - 5)
  
  'Wagerechte Linie
  frmmain.picDiagramm.Line (15, frmmain.picDiagramm.ScaleHeight - 5)-(frmmain.picDiagramm.ScaleWidth - 15, frmmain.picDiagramm.ScaleHeight - 5)
  
  'Beschrftung Zeit
  frmmain.picDiagramm.CurrentX = frmmain.picDiagramm.ScaleWidth - 9
  frmmain.picDiagramm.CurrentY = frmmain.picDiagramm.ScaleHeight - 7
  frmmain.picDiagramm.Print "Zeit"
  
  'Beschrftung Wert
  frmmain.picDiagramm.CurrentX = 15
  frmmain.picDiagramm.CurrentY = 1
  frmmain.picDiagramm.Print "Wert"
  
  'Grten Wert finden
  For i = 1 To UBound(Points) - 1
    Gre = Points(i).Wert
    If Gre > Grter Then Grter = Points(i).Wert
    If Points(i).Uhrzeit = "" Then Exit For
  Next i
  
  'Variablen mit allgemeinen Maen
  Hhe = frmmain.picDiagramm.ScaleHeight - 10
  Breite = frmmain.picDiagramm.ScaleWidth - 30          'Plus Rundung auf Millimeter
  
  'Wert an der Y Achse skalieren
  'In den Schritten des Zurckgegeben Wertes
  Skalierung = PassendRunden(Grter) / Grter:  If Skalierung = 0 Then Exit Sub
  For i = 1 To Int(Grter / PassendRunden(Grter)) + 1
    Y = (Hhe + 5) - (Hhe * Skalierung * i)  'Mittig Positionieren, desswegen + 4
    frmmain.picDiagramm.CurrentX = 5
    frmmain.picDiagramm.CurrentY = Y
    frmmain.picDiagramm.Font.Size = 10 - Len(frmmain.txtSkalierung.Text)
    frmmain.picDiagramm.Print PassendRunden(Grter) * i
  Next
  
  'Wert an der X Achse skalieren
  For i = 0 To 24 Step 2
    X = ((Breite / 24) * i + 1) + 12
    Y = Hhe
    frmmain.picDiagramm.CurrentX = X
    frmmain.picDiagramm.CurrentY = Y + 6
    frmmain.picDiagramm.Font.Size = 8
    frmmain.picDiagramm.Print i 'Ausgeben
  Next i
  
  'Horizontales Raster
  frmmain.picDiagramm.DrawStyle = 2
  frmmain.picDiagramm.ForeColor = &H8000000F
  For i = 1 To Int(Grter / PassendRunden(Grter)) + 1
    Y = (Hhe + 5) - (Hhe * Skalierung * i)  'Mittig Positionieren, desswegen + 5
    frmmain.picDiagramm.CurrentX = 6
    frmmain.picDiagramm.CurrentY = Y
    frmmain.picDiagramm.Line (15, Y)-(Breite + 15, Y)
  Next
  frmmain.picDiagramm.ForeColor = vbBlack
  frmmain.picDiagramm.DrawStyle = 0
End Sub

Sub SulenDiagramm()
  On Error Resume Next
  
  'Wenn keine Datei geladen
  If Points(1).Uhrzeit = "" Then Exit Sub

  'Grten Wert finden
  For i = 1 To UBound(Points) - 1
    Gre = Points(i).Wert
    If Gre > Grter Then Grter = Points(i).Wert
    If Points(i).Uhrzeit = "" Then Exit For
  Next i
  
  'Variablen mit allgemeinen Maen
  Hhe = frmmain.picDiagramm.ScaleHeight - 10
  Breite = frmmain.picDiagramm.ScaleWidth - 30
  
  'Multiplikator
  Mal = (Hhe / (PassendRunden(Grter) * (Grter / PassendRunden(Grter)))) ' Anmerkung: Statt Grter Gerundetter!
  
  'Nullpunkt
  LastX = 15
  LastY = Hhe
  
 'Diagramm zeichnen
  For i = 1 To UBound(Points) - 1
    If Points(i).Uhrzeit = "" Then Exit For

    CurrentY = Hhe - Points(i).Wert * Mal            'Hhe von der aktuellen Uhrzeit
    CurrentX = GetXFromTime(Points(i).Uhrzeit)        'Rckgabe der Position X von der Aktuellen Uhrzeit
    
    If frmmain.picDiagramm.ForeColor = vbBlue Then
      frmmain.picDiagramm.ForeColor = vbRed
    Else
      frmmain.picDiagramm.ForeColor = vbBlue
    End If

    frmmain.picDiagramm.Line (CurrentX + (Breite / 24 / 4) - 1, CurrentY + 5)-(CurrentX, Hhe + 5), , BF
  Next i
  
  'Standart
  frmmain.picDiagramm.ForeColor = vbBlack
  frmmain.picDiagramm.DrawWidth = 1
  frmmain.picDiagramm.DrawStyle = 0
End Sub

Sub LinienDiagramm()
  On Error Resume Next
  
  'Wenn keine Datei geladen
  If Points(1).Uhrzeit = "" Then Exit Sub

  'Grten Wert finden
  For i = 1 To UBound(Points) - 1
    Gre = Points(i).Wert
    If Gre > Grter Then Grter = Points(i).Wert
    If Points(i).Uhrzeit = "" Then Exit For
  Next i
  
  'Variablen mit allgemeinen Maen
  Hhe = frmmain.picDiagramm.ScaleHeight - 10
  Breite = frmmain.picDiagramm.ScaleWidth - 30
  
  'Multiplikator
  Mal = (Hhe / (PassendRunden(Grter) * (Grter / PassendRunden(Grter)))) ' Anmerkung: Statt Grter Gerundetter!
  
  'Nullpunkt
  LastX = 15
  LastY = Hhe
  
  For i = 1 To UBound(Points) - 1
    If Points(i).Uhrzeit = "" Then Exit For

    CurrentY = Hhe - Points(i).Wert * Mal            'Hhe von der aktuellen Uhrzeit
    CurrentX = GetXFromTime(Points(i).Uhrzeit)        'Rckgabe der Position X von der Aktuellen Uhrzeit
    
    frmmain.picDiagramm.DrawWidth = frmmain.txtBreite.Text
    frmmain.picDiagramm.DrawStyle = frmmain.cboLinienart.ListIndex
    
    'Farbe
    Dim Farbe As ColorConstants
    Select Case Points(i).Linie
      Case 1
        Farbe = vbBlack
      Case 2
        Farbe = vbBlue
      Case 3
        Farbe = vbRed
      Case 4
        Farbe = vbMagenta
      Case 5
        Farbe = vbCyan
      Case Is > 5
        Farbe = vbBlack
    End Select
    frmmain.picDiagramm.ForeColor = Farbe
    
    If IsNextPoint(Points(i - 1).Uhrzeit, Points(i).Uhrzeit) Then
      'Nchster Punkt
      frmmain.picDiagramm.Line (LastX, LastY + 5)-(CurrentX, CurrentY + 5)
    Else
      'Wenn keine Viertelstunde Unterschied, nur einen kleinen Punkt zeichnen
      frmmain.picDiagramm.PSet (CurrentX, CurrentY + 5)
    End If
    frmmain.picDiagramm.ForeColor = vbBlack
    
    LastX = CurrentX                                  'Letzte LinienPos
    LastY = CurrentY                                  'Letzte Linien Pos
  Next i
  
  'Standart
  frmmain.picDiagramm.DrawWidth = 1
  frmmain.picDiagramm.DrawStyle = 0
End Sub

Function GetXFromTime(Uhrzeit As String) As Integer 'Position auf der x Achse ermitteln
  On Error Resume Next
  
  Stunden = Mid$(Uhrzeit, 1, 2)  'Rckgabe der Stunden
  Minuten = Mid$(Uhrzeit, 4, 2)  'Rckgabe Minuten
  
  Breite = frmmain.picDiagramm.ScaleWidth - 30
                                                    
  Position = Breite / 24 * Stunden                  'Position der Stunde auf der X Achse
  Position = Position + Breite / 24 / 60 * Minuten  'Position der Minuten auf der X Achse
  
  Position = Position + 15                          'Linker Rand!
  
  GetXFromTime = Position                           'Rckgabe der X Position
End Function

Function IsNextPoint(Uhrzeit As String, Neu As String) As Boolean
  On Error Resume Next
  
  altstunden = Int(Mid$(Uhrzeit, 1, 2))  'Rckgabe der Stunden
  Altminuten = Int(Mid$(Uhrzeit, 4, 2))  'Rckgabe Minuten
  neustunden = Int(Mid$(Neu, 1, 2))      'Rckgabe der Stunden
  neuminuten = Int(Mid$(Neu, 4, 2))      'Rckgabe Minuten
  
  If Uhrzeit = "" Then Exit Function
  If Neu = "" Then Exit Function
  
  If Altminuten = "45" And neustunden = altstunden + 1 Then
    'ok
    IsNextPoint = True
  ElseIf neuminuten = Altminuten + 15 And neustunden = altstunden Then
      'ok
    IsNextPoint = True
  Else
    IsNextPoint = False
  End If
  
End Function

Function PassendRunden(Zahl) As Double
  'Wenn Benutzereingabe
  If frmmain.txtSkalierung.Enabled = True Then PassendRunden = frmmain.txtSkalierung.Text: Exit Function
  
  Zahl = CStr(Zahl)
  Lnge = Len(Zahl)
  If Zahl > 200 Then
    Rckgabe = CDbl(1 & String(Lnge - 1, "0"))  'Beispiel:  Zahl=14367; Rck=1000
  Else
    Rckgabe = CDbl(1 & String(Lnge - 2, "0"))  'Beispiel:  Zahl=143; Rck=10
  End If
  
  If Rckgabe Mod Rckgabe = 0 Then
    'Glatte Zahl, Beispiel: 41000
    'Nichts machen, nicht aufrunden
  Else
    'Nicht glatt, Beispiel: 41001
    'Aufrunden
    Rckgabe = Rckgabe * (Int(Zahl / Rckgabe) + 1)
  End If
  PassendRunden = Rckgabe
End Function
