Attribute VB_Name = "Drucken"
Sub Drucken()
  Set Printer = Printers(frmDrucken.cboPrinter.ListIndex)  'Drucker whlen
  
  'Papierformat Hoch/Breit
  If frmDrucken.optHochformat.Value = True Then
    Printer.Orientation = vbPRORPortrait  'Hoch
  Else
    Printer.Orientation = vbPRORLandscape 'Breit
  End If
  
  If frmDrucken.optFarbe.Value Then
    Printer.ColorMode = vbPRCMColor
  Else
    Printer.ColorMode = PrinterObjectConstants.vbPRCMMonochrome
  End If
  
  Printer.ScaleMode = 6
  
  Hilflinien                                                  'Skalierung, Hilflinien, usw. drucken
  Diagramm                                                    'Diagramm drucken
  Printer.EndDoc                                              'Ausdruck starten
End Sub

Sub Hilflinien()
  On Error Resume Next
  'Senkrechte Linie
  Printer.Line (15, 5)-(15, Printer.ScaleHeight - 5)
  
  'Wagerechte Linie
  Printer.Line (15, Printer.ScaleHeight - 5)-(Printer.ScaleWidth - 15, Printer.ScaleHeight - 5)
  
  'Beschrftung Zeit
  Printer.CurrentX = Printer.ScaleWidth - 9
  Printer.CurrentY = Printer.ScaleHeight - 7
  Printer.Print "Zeit"
  
  'Beschrftung Wert
  Printer.CurrentX = 15
  Printer.CurrentY = 1
  Printer.Print "Wert"
  
  'Grten Wert finden
  For i = 1 To UBound(Points) - 1
    Gre = Points(i).Wert
    If Gre > Grter Then Grter = Points(i).Wert
    If Points(i).Uhrzeit = "" Then Exit For
  Next i
  
  'Variablen mit allgemeinen Maen
  Hhe = Printer.ScaleHeight - 10
  Breite = Printer.ScaleWidth - 30          'Plus Rundung auf Millimeter
  
  'Wert an der Y Achse skalieren
  'In den Schritten des Zurckgegeben Wertes
  Skalierung = PassendRunden(Grter) / Grter:  If Skalierung = 0 Then Exit Sub
  For i = 1 To Int(Grter / PassendRunden(Grter)) + 1
    Y = (Hhe + 5) - (Hhe * Skalierung * i)  'Mittig Positionieren, desswegen + 4
    Printer.CurrentX = 5
    Printer.CurrentY = Y
    Printer.Font.Size = 10 - Len(frmmain.txtSkalierung.Text)
    Printer.Print PassendRunden(Grter) * i
  Next
  
  'Wert an der X Achse skalieren
  For i = 0 To 24 Step 2
    X = ((Breite / 24) * i + 1) + 12
    Y = Hhe
    Printer.CurrentX = X
    Printer.CurrentY = Y + 6
    Printer.Font.Size = 8
    Printer.Print i 'Ausgeben
  Next i
  
  'Horizontales Raster
  Printer.DrawStyle = 2
  Printer.ForeColor = &H8000000F
  For i = 1 To Int(Grter / PassendRunden(Grter)) + 1
    Y = (Hhe + 5) - (Hhe * Skalierung * i)  'Mittig Positionieren, desswegen + 5
    Printer.CurrentX = 6
    Printer.CurrentY = Y
    Printer.Line (15, Y)-(Breite + 15, Y)
  Next
  Printer.ForeColor = vbBlack
  Printer.DrawStyle = 0
End Sub

Sub Diagramm()
  On Error Resume Next
  
  'Wenn keine Datei geladen
  If Points(1).Uhrzeit = "" Then Exit Sub

  'Grten Wert finden
  For i = 1 To UBound(Points) - 1
    Gre = Points(i).Wert
    If Gre > Grter Then Grter = Points(i).Wert
    If Points(i).Uhrzeit = "" Then Exit For
  Next i
  
  'Variablen mit allgemeinen Maen
  Hhe = Printer.ScaleHeight - 10
  Breite = Printer.ScaleWidth - 30
  
  'Multiplikator
  Mal = (Hhe / (PassendRunden(Grter) * (Grter / PassendRunden(Grter)))) ' Anmerkung: Statt Grter Gerundetter!
  
  'Nullpunkt
  LastX = 15
  LastY = Hhe
  
  For i = 1 To UBound(Points) - 1
    If Points(i).Uhrzeit = "" Then Exit For

    CurrentY = Hhe - Points(i).Wert * Mal            'Hhe von der aktuellen Uhr
    CurrentX = GetXFromTime(Points(i).Uhrzeit)        'Rckgabe der Position X von der Aktuellen Uhrzeit
    
    'Farbe
    Dim Farbe As ColorConstants
    Select Case Points(i).Linie
      Case 1
        Farbe = vbBlack
      Case 2
        Farbe = vbBlue
      Case 3
        Farbe = vbRed
      Case 4
        Farbe = vbMagenta
      Case 5
        Farbe = vbCyan
      Case Is > 5
        Farbe = vbBlack
    End Select
    Printer.ForeColor = Farbe

    
    Printer.DrawWidth = frmmain.txtBreite.Text * 2
    Printer.DrawStyle = frmmain.cboLinienart.ListIndex
    
    If IsNextPoint(Points(i - 1).Uhrzeit, Points(i).Uhrzeit) Then
      'Nchster Punkt
      Printer.Line (LastX, LastY + 5)-(CurrentX, CurrentY + 5)
    Else
      'Wenn keine Viertelstunde Unterschied, nur einen kleinen Punkt zeichnen
      Printer.PSet (CurrentX, CurrentY + 5)
    End If
    Printer.ForeColor = vbBlack
    
    LastX = CurrentX                                  'Letzte LinienPos
    LastY = CurrentY                                  'Letzte Linien Pos
  Next i
  
  'Standart
  Printer.DrawWidth = 1
  Printer.DrawStyle = 0
End Sub

Function GetXFromTime(Uhrzeit As String) As Integer 'Position auf der x Achse ermitteln
  On Error Resume Next
  
  Stunden = Mid$(Uhrzeit, 1, 2)  'Rckgabe der Stunden
  Minuten = Mid$(Uhrzeit, 4, 2)  'Rckgabe Minuten
  
  Breite = Printer.ScaleWidth - 30
                                                    
  Position = Breite / 24 * Stunden                  'Position der Stunde auf der X Achse
  Position = Position + Breite / 24 / 60 * Minuten  'Position der Minuten auf der X Achse
  
  Position = Position + 15                          'Linker Rand!
  
  GetXFromTime = Position                           'Rckgabe der X Position
End Function

